#include "plexus_test.h"

START_TEST(nick)
{
  plexus_up();

  struct PlexusClient *client1 = client_register("test1"),
                      *client2 = client_register("test2");

  irc_nick(client1, "test3");
  expect_nickchange_to(client1, client1->client, "test3");
  strlcpy(client1->name, "test3", sizeof(client1->name));
  ck_assert_str_eq(client1->client->name, "test3");

  irc_join(client1, "#a");
  expect_message(client1, client1->client, "JOIN");

  irc_join(client2, "#a");
  expect_message(client2, client2->client, "JOIN");

  struct Channel *chptr = hash_find_channel("#a");
  ck_assert_ptr_ne(chptr, NULL);

  irc_nick(client1, "test4");
  expect_nickchange_to(client1, client1->client, "test4");
  strlcpy(client1->name, "test4", sizeof(client1->name));
  ck_assert_str_eq(client1->client->name, "test4");

  expect_nickchange_from(client2, client1->client, "test3");
}
END_TEST

void
nick_setup(Suite *s)
{
  TCase *tc = tcase_create("nick");

  tcase_add_checked_fixture(tc, NULL, plexus_down);
  tcase_add_test(tc, nick);

  suite_add_tcase(s, tc);
}
