/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 28 "conf_parser.y" /* yacc.c:339  */


#define YY_NO_UNPUT
#include <sys/types.h>
#include <string.h>

#include "config.h"
#include "stdinc.h"
#include "ircd.h"
#include "list.h"
#include "conf.h"
#include "conf_class.h"
#include "event.h"
#include "log.h"
#include "client.h"	/* for UMODE_ALL only */
#include "irc_string.h"
#include "memory.h"
#include "modules.h"
#include "s_serv.h"
#include "hostmask.h"
#include "send.h"
#include "listener.h"
#include "resv.h"
#include "numeric.h"
#include "s_user.h"
#include "motd.h"
#include "hook.h"
#include "ssl.h"

#include <openssl/rsa.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#include <openssl/dh.h>

#include "rsa.h"

int yylex(void);

static struct
{
  struct {
    dlink_list list;
  } mask,
    leaf,
    hub;

  struct {
    char buf[IRCD_BUFSIZE];
  } name,
    user,
    host,
    addr,
    bind,
    file,
    cert,
    ca,
    profile,
    rpass,
    spass,
    class,
    reason;

  struct {
    unsigned int value;
  } flags,
    modes,
    snomask_local,
    snomask_remote,
    size,
    type,
    port,
    aftype,
    ping_freq,
    max_perip,
    con_freq,
    min_idle,
    max_idle,
    max_total,
    max_global,
    max_local,
    max_ident,
    soft_sendq,
    flood_burst,
    flood_limit,
    max_sendq,
    max_recvq,
    cidr_bitlen_ipv4,
    cidr_bitlen_ipv6,
    number_per_cidr;

  struct
  {
    struct alias_entry *alias;
    struct sslprofile *ssl;
    struct sslprofile_identity *identity;
    struct dnsbl_entry *dnsbl;
  } ptr;
} block_state;

static void
reset_block_state(void)
{
  dlink_node *ptr = NULL, *ptr_next = NULL;

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.mask.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.mask.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.leaf.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.leaf.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.hub.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.hub.list);
    free_dlink_node(ptr);
  }

  memset(&block_state, 0, sizeof(block_state));
}


#line 196 "conf_parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_CONF_PARSER_H_INCLUDED
# define YY_YY_CONF_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACCEPT_PASSWORD = 258,
    ACCOUNT_WHOIS = 259,
    ADMIN = 260,
    AFTYPE = 261,
    ANTI_NICK_FLOOD = 262,
    ANTI_SPAM_EXIT_MESSAGE_TIME = 263,
    AUTOCONN = 264,
    BYTES = 265,
    KBYTES = 266,
    MBYTES = 267,
    CA_FILE = 268,
    CALLER_ID_WAIT = 269,
    CAN_FLOOD = 270,
    CHANNEL = 271,
    CIDR_BITLEN_IPV4 = 272,
    CIDR_BITLEN_IPV6 = 273,
    CIPHER_LIST = 274,
    CLASS = 275,
    CLOAK_KEY1 = 276,
    CLOAK_KEY2 = 277,
    CLOAK_KEY3 = 278,
    CLOAK_WHOIS_ACTUALLY = 279,
    CONNECT = 280,
    CONNECTFREQ = 281,
    CYCLE_ON_HOST_CHANGE = 282,
    DEFAULT_FLOODCOUNT = 283,
    DEFAULT_SPLIT_SERVER_COUNT = 284,
    DEFAULT_SPLIT_USER_COUNT = 285,
    DEFER = 286,
    DENY = 287,
    DESCRIPTION = 288,
    DIE = 289,
    DISABLE_AUTH = 290,
    DISABLE_CHMODES = 291,
    DISABLE_FAKE_CHANNELS = 292,
    DISABLE_REMOTE_COMMANDS = 293,
    DNSBL = 294,
    DNSBL_EXEMPT = 295,
    DOTS_IN_IDENT = 296,
    DURATION = 297,
    EMAIL = 298,
    ENABLE_EXTBANS = 299,
    ENABLE_FORWARDING = 300,
    ENCRYPTED = 301,
    EXCEED_LIMIT = 302,
    EXEMPT = 303,
    FAILED_OPER_NOTICE = 304,
    FLATTEN_LINKS = 305,
    FLOOD_BURST = 306,
    FLOOD_LIMIT = 307,
    GECOS = 308,
    GENERAL = 309,
    GLINE = 310,
    GLINE_DURATION = 311,
    GLINE_ENABLE = 312,
    GLINE_EXEMPT = 313,
    GLINE_MIN_CIDR = 314,
    GLINE_MIN_CIDR6 = 315,
    GLINE_REQUEST_DURATION = 316,
    HAVENT_READ_CONF = 317,
    HIDDEN = 318,
    HIDDEN_NAME = 319,
    HIDE_IDLE_FROM_OPERS = 320,
    HIDE_SERVER_IPS = 321,
    HIDE_SERVERS = 322,
    HIDE_SERVICES = 323,
    HIDE_SPOOF_IPS = 324,
    HOST = 325,
    HTTP = 326,
    HUB = 327,
    HUB_MASK = 328,
    IDENTITY = 329,
    IGNORE_BOGUS_TS = 330,
    INVISIBLE_ON_CONNECT = 331,
    INVITE_THROTTLE = 332,
    IP = 333,
    IRCD_AUTH = 334,
    IRCD_FLAGS = 335,
    IRCD_SID = 336,
    JOIN_FLOOD_COUNT = 337,
    JOIN_FLOOD_TIME = 338,
    KILL = 339,
    KILL_CHASE_TIME_LIMIT = 340,
    KLINE = 341,
    KLINE_EXEMPT = 342,
    KLINE_REASON = 343,
    KNOCK_DELAY = 344,
    KNOCK_DELAY_CHANNEL = 345,
    LEAF_MASK = 346,
    T_LINK = 347,
    LINKS_DELAY = 348,
    LISTEN = 349,
    MASK = 350,
    MATCH = 351,
    MAX_ACCEPT = 352,
    MAX_BANS = 353,
    MAX_CHANS_PER_OPER = 354,
    MAX_CHANS_PER_USER = 355,
    MAX_GLOBAL = 356,
    MAX_IDENT = 357,
    MAX_IDLE = 358,
    MAX_LOCAL = 359,
    MAX_NICK_CHANGES = 360,
    MAX_NICK_LENGTH = 361,
    MAX_NICK_TIME = 362,
    MAX_NUMBER = 363,
    MAX_TARGETS = 364,
    MAX_TOPIC_LENGTH = 365,
    MAX_WATCH = 366,
    MIN_IDLE = 367,
    MIN_NONWILDCARD = 368,
    MIN_NONWILDCARD_SIMPLE = 369,
    MODULE = 370,
    MODULES = 371,
    MOTD = 372,
    NAME = 373,
    NEED_ACCOUNT = 374,
    NEED_IDENT = 375,
    NEED_PASSWORD = 376,
    NETWORK_DESC = 377,
    NETWORK_NAME = 378,
    NICK = 379,
    NICK_COLLIDE_REALHOST = 380,
    NO_CREATE_ON_SPLIT = 381,
    NO_JOIN_ON_SPLIT = 382,
    NO_OPER_FLOOD = 383,
    NO_TILDE = 384,
    NUMBER = 385,
    NUMBER_PER_CIDR = 386,
    NUMBER_PER_IP = 387,
    OPER_ONLY = 388,
    OPER_ONLY_UMODES = 389,
    OPER_PASS_RESV = 390,
    OPER_SNOMASKS = 391,
    OPER_UMODES = 392,
    OPERATOR = 393,
    OPERS_BYPASS_CALLERID = 394,
    PACE_WAIT = 395,
    PACE_WAIT_SIMPLE = 396,
    PASSWORD = 397,
    PATH = 398,
    PING_COOKIE = 399,
    PING_TIME = 400,
    PORT = 401,
    QSTRING = 402,
    QUIET_ON_BAN = 403,
    RANDOM_IDLE = 404,
    REASON = 405,
    REDIRPORT = 406,
    REDIRSERV = 407,
    REHASH = 408,
    REMOTE = 409,
    REMOTEBAN = 410,
    RESV = 411,
    RESV_EXEMPT = 412,
    RSA_PRIVATE_KEY_FILE = 413,
    RSA_PUBLIC_KEY_FILE = 414,
    SCRIPT = 415,
    SECONDS = 416,
    MINUTES = 417,
    HOURS = 418,
    DAYS = 419,
    WEEKS = 420,
    MONTHS = 421,
    YEARS = 422,
    SEND_PASSWORD = 423,
    SENDQ = 424,
    SERVERHIDE = 425,
    SERVERINFO = 426,
    SERVER_NAME = 427,
    SHORT_MOTD = 428,
    T_SNOMASKS = 429,
    SOFT_SENDQ = 430,
    SPOOF = 431,
    SPOOF_NOTICE = 432,
    SQUIT = 433,
    SSL_CERTIFICATE_FILE = 434,
    SSL_CERTIFICATE_FINGERPRINT = 435,
    SSL_CONNECTION_REQUIRED = 436,
    SSL_DH_ELLIPTIC_CURVE = 437,
    SSL_DH_PARAM_FILE = 438,
    SSL_MESSAGE_DIGEST_ALGORITHM = 439,
    STATS_E_DISABLED = 440,
    STATS_I_OPER_ONLY = 441,
    STATS_K_OPER_ONLY = 442,
    STATS_M_OPER_ONLY = 443,
    STATS_O_OPER_ONLY = 444,
    STATS_P_OPER_ONLY = 445,
    STATS_U_OPER_ONLY = 446,
    T_ALIAS = 447,
    T_ALL = 448,
    T_BOTS = 449,
    T_CALLERID = 450,
    T_CCONN = 451,
    T_CLUSTER = 452,
    T_DEAF = 453,
    T_DEBUG = 454,
    T_DLINE = 455,
    T_FARCONNECT = 456,
    T_FILE = 457,
    T_FULL = 458,
    T_HIDECHANNELS = 459,
    T_GLOBOPS = 460,
    T_INVISIBLE = 461,
    T_IPV4 = 462,
    T_IPV6 = 463,
    T_LOCOPS = 464,
    T_LOG = 465,
    T_MAX_CLIENTS = 466,
    T_NCHANGE = 467,
    T_NOCTCP = 468,
    T_NONONREG = 469,
    T_OPERWALL = 470,
    T_RECVQ = 471,
    T_REJ = 472,
    T_RESTART = 473,
    T_SASL_NAME = 474,
    T_SERVER = 475,
    T_SERVICE = 476,
    T_SERVICES_NAME = 477,
    T_SERVNOTICE = 478,
    T_SET = 479,
    T_SHARED = 480,
    T_SIZE = 481,
    T_SKILL = 482,
    T_SOFTCALLERID = 483,
    T_SPY = 484,
    T_SSL = 485,
    SSLPROFILE = 486,
    SSL_PROFILE = 487,
    T_UMODES = 488,
    T_UNAUTH = 489,
    T_UNDLINE = 490,
    T_UNLIMITED = 491,
    T_UNRESV = 492,
    T_UNXLINE = 493,
    T_WALLOP = 494,
    T_WALLOPS = 495,
    T_WALLUSERS = 496,
    T_WEBIRC = 497,
    TBOOL = 498,
    THROTTLE_NUM = 499,
    THROTTLE_TIME = 500,
    TKLINE_EXPIRE_NOTICES = 501,
    TMASKED = 502,
    TS_MAX_DELTA = 503,
    TS_WARN_DELTA = 504,
    TWODOTS = 505,
    TYPE = 506,
    UNKLINE = 507,
    USE_LOGGING = 508,
    USE_TARGET_CHANGE = 509,
    USER = 510,
    VHOST = 511,
    VHOST6 = 512,
    WARN_NO_NLINE = 513,
    XLINE = 514
  };
#endif
/* Tokens.  */
#define ACCEPT_PASSWORD 258
#define ACCOUNT_WHOIS 259
#define ADMIN 260
#define AFTYPE 261
#define ANTI_NICK_FLOOD 262
#define ANTI_SPAM_EXIT_MESSAGE_TIME 263
#define AUTOCONN 264
#define BYTES 265
#define KBYTES 266
#define MBYTES 267
#define CA_FILE 268
#define CALLER_ID_WAIT 269
#define CAN_FLOOD 270
#define CHANNEL 271
#define CIDR_BITLEN_IPV4 272
#define CIDR_BITLEN_IPV6 273
#define CIPHER_LIST 274
#define CLASS 275
#define CLOAK_KEY1 276
#define CLOAK_KEY2 277
#define CLOAK_KEY3 278
#define CLOAK_WHOIS_ACTUALLY 279
#define CONNECT 280
#define CONNECTFREQ 281
#define CYCLE_ON_HOST_CHANGE 282
#define DEFAULT_FLOODCOUNT 283
#define DEFAULT_SPLIT_SERVER_COUNT 284
#define DEFAULT_SPLIT_USER_COUNT 285
#define DEFER 286
#define DENY 287
#define DESCRIPTION 288
#define DIE 289
#define DISABLE_AUTH 290
#define DISABLE_CHMODES 291
#define DISABLE_FAKE_CHANNELS 292
#define DISABLE_REMOTE_COMMANDS 293
#define DNSBL 294
#define DNSBL_EXEMPT 295
#define DOTS_IN_IDENT 296
#define DURATION 297
#define EMAIL 298
#define ENABLE_EXTBANS 299
#define ENABLE_FORWARDING 300
#define ENCRYPTED 301
#define EXCEED_LIMIT 302
#define EXEMPT 303
#define FAILED_OPER_NOTICE 304
#define FLATTEN_LINKS 305
#define FLOOD_BURST 306
#define FLOOD_LIMIT 307
#define GECOS 308
#define GENERAL 309
#define GLINE 310
#define GLINE_DURATION 311
#define GLINE_ENABLE 312
#define GLINE_EXEMPT 313
#define GLINE_MIN_CIDR 314
#define GLINE_MIN_CIDR6 315
#define GLINE_REQUEST_DURATION 316
#define HAVENT_READ_CONF 317
#define HIDDEN 318
#define HIDDEN_NAME 319
#define HIDE_IDLE_FROM_OPERS 320
#define HIDE_SERVER_IPS 321
#define HIDE_SERVERS 322
#define HIDE_SERVICES 323
#define HIDE_SPOOF_IPS 324
#define HOST 325
#define HTTP 326
#define HUB 327
#define HUB_MASK 328
#define IDENTITY 329
#define IGNORE_BOGUS_TS 330
#define INVISIBLE_ON_CONNECT 331
#define INVITE_THROTTLE 332
#define IP 333
#define IRCD_AUTH 334
#define IRCD_FLAGS 335
#define IRCD_SID 336
#define JOIN_FLOOD_COUNT 337
#define JOIN_FLOOD_TIME 338
#define KILL 339
#define KILL_CHASE_TIME_LIMIT 340
#define KLINE 341
#define KLINE_EXEMPT 342
#define KLINE_REASON 343
#define KNOCK_DELAY 344
#define KNOCK_DELAY_CHANNEL 345
#define LEAF_MASK 346
#define T_LINK 347
#define LINKS_DELAY 348
#define LISTEN 349
#define MASK 350
#define MATCH 351
#define MAX_ACCEPT 352
#define MAX_BANS 353
#define MAX_CHANS_PER_OPER 354
#define MAX_CHANS_PER_USER 355
#define MAX_GLOBAL 356
#define MAX_IDENT 357
#define MAX_IDLE 358
#define MAX_LOCAL 359
#define MAX_NICK_CHANGES 360
#define MAX_NICK_LENGTH 361
#define MAX_NICK_TIME 362
#define MAX_NUMBER 363
#define MAX_TARGETS 364
#define MAX_TOPIC_LENGTH 365
#define MAX_WATCH 366
#define MIN_IDLE 367
#define MIN_NONWILDCARD 368
#define MIN_NONWILDCARD_SIMPLE 369
#define MODULE 370
#define MODULES 371
#define MOTD 372
#define NAME 373
#define NEED_ACCOUNT 374
#define NEED_IDENT 375
#define NEED_PASSWORD 376
#define NETWORK_DESC 377
#define NETWORK_NAME 378
#define NICK 379
#define NICK_COLLIDE_REALHOST 380
#define NO_CREATE_ON_SPLIT 381
#define NO_JOIN_ON_SPLIT 382
#define NO_OPER_FLOOD 383
#define NO_TILDE 384
#define NUMBER 385
#define NUMBER_PER_CIDR 386
#define NUMBER_PER_IP 387
#define OPER_ONLY 388
#define OPER_ONLY_UMODES 389
#define OPER_PASS_RESV 390
#define OPER_SNOMASKS 391
#define OPER_UMODES 392
#define OPERATOR 393
#define OPERS_BYPASS_CALLERID 394
#define PACE_WAIT 395
#define PACE_WAIT_SIMPLE 396
#define PASSWORD 397
#define PATH 398
#define PING_COOKIE 399
#define PING_TIME 400
#define PORT 401
#define QSTRING 402
#define QUIET_ON_BAN 403
#define RANDOM_IDLE 404
#define REASON 405
#define REDIRPORT 406
#define REDIRSERV 407
#define REHASH 408
#define REMOTE 409
#define REMOTEBAN 410
#define RESV 411
#define RESV_EXEMPT 412
#define RSA_PRIVATE_KEY_FILE 413
#define RSA_PUBLIC_KEY_FILE 414
#define SCRIPT 415
#define SECONDS 416
#define MINUTES 417
#define HOURS 418
#define DAYS 419
#define WEEKS 420
#define MONTHS 421
#define YEARS 422
#define SEND_PASSWORD 423
#define SENDQ 424
#define SERVERHIDE 425
#define SERVERINFO 426
#define SERVER_NAME 427
#define SHORT_MOTD 428
#define T_SNOMASKS 429
#define SOFT_SENDQ 430
#define SPOOF 431
#define SPOOF_NOTICE 432
#define SQUIT 433
#define SSL_CERTIFICATE_FILE 434
#define SSL_CERTIFICATE_FINGERPRINT 435
#define SSL_CONNECTION_REQUIRED 436
#define SSL_DH_ELLIPTIC_CURVE 437
#define SSL_DH_PARAM_FILE 438
#define SSL_MESSAGE_DIGEST_ALGORITHM 439
#define STATS_E_DISABLED 440
#define STATS_I_OPER_ONLY 441
#define STATS_K_OPER_ONLY 442
#define STATS_M_OPER_ONLY 443
#define STATS_O_OPER_ONLY 444
#define STATS_P_OPER_ONLY 445
#define STATS_U_OPER_ONLY 446
#define T_ALIAS 447
#define T_ALL 448
#define T_BOTS 449
#define T_CALLERID 450
#define T_CCONN 451
#define T_CLUSTER 452
#define T_DEAF 453
#define T_DEBUG 454
#define T_DLINE 455
#define T_FARCONNECT 456
#define T_FILE 457
#define T_FULL 458
#define T_HIDECHANNELS 459
#define T_GLOBOPS 460
#define T_INVISIBLE 461
#define T_IPV4 462
#define T_IPV6 463
#define T_LOCOPS 464
#define T_LOG 465
#define T_MAX_CLIENTS 466
#define T_NCHANGE 467
#define T_NOCTCP 468
#define T_NONONREG 469
#define T_OPERWALL 470
#define T_RECVQ 471
#define T_REJ 472
#define T_RESTART 473
#define T_SASL_NAME 474
#define T_SERVER 475
#define T_SERVICE 476
#define T_SERVICES_NAME 477
#define T_SERVNOTICE 478
#define T_SET 479
#define T_SHARED 480
#define T_SIZE 481
#define T_SKILL 482
#define T_SOFTCALLERID 483
#define T_SPY 484
#define T_SSL 485
#define SSLPROFILE 486
#define SSL_PROFILE 487
#define T_UMODES 488
#define T_UNAUTH 489
#define T_UNDLINE 490
#define T_UNLIMITED 491
#define T_UNRESV 492
#define T_UNXLINE 493
#define T_WALLOP 494
#define T_WALLOPS 495
#define T_WALLUSERS 496
#define T_WEBIRC 497
#define TBOOL 498
#define THROTTLE_NUM 499
#define THROTTLE_TIME 500
#define TKLINE_EXPIRE_NOTICES 501
#define TMASKED 502
#define TS_MAX_DELTA 503
#define TS_WARN_DELTA 504
#define TWODOTS 505
#define TYPE 506
#define UNKLINE 507
#define USE_LOGGING 508
#define USE_TARGET_CHANGE 509
#define USER 510
#define VHOST 511
#define VHOST6 512
#define WARN_NO_NLINE 513
#define XLINE 514

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 158 "conf_parser.y" /* yacc.c:355  */

  int number;
  char *string;

#line 759 "conf_parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CONF_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 776 "conf_parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1546

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  266
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  344
/* YYNRULES -- Number of rules.  */
#define YYNRULES  755
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1511

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   514

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   264,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   265,   260,
       2,   263,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   262,     2,   261,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   421,   421,   422,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     454,   454,   455,   459,   463,   467,   471,   475,   479,   483,
     489,   489,   490,   491,   492,   493,   500,   499,   514,   514,
     515,   515,   515,   515,   515,   517,   530,   536,   542,   554,
     557,   557,   558,   558,   558,   558,   560,   566,   572,   580,
     579,   628,   628,   629,   629,   629,   630,   630,   631,   632,
     634,   642,   674,   700,   708,   717,   716,   738,   738,   739,
     739,   740,   741,   743,   758,   818,   859,   861,   861,   862,
     862,   863,   863,   864,   864,   865,   865,   866,   867,   868,
     869,   872,   887,   902,   911,   925,   934,   962,   992,  1017,
    1039,  1061,  1070,  1072,  1072,  1073,  1073,  1074,  1074,  1076,
    1085,  1094,  1107,  1106,  1124,  1124,  1125,  1125,  1125,  1127,
    1133,  1144,  1143,  1160,  1160,  1162,  1162,  1162,  1162,  1164,
    1170,  1176,  1177,  1177,  1178,  1203,  1204,  1204,  1206,  1206,
    1207,  1209,  1216,  1216,  1229,  1230,  1232,  1232,  1233,  1233,
    1235,  1243,  1246,  1252,  1251,  1257,  1257,  1258,  1262,  1266,
    1270,  1274,  1278,  1282,  1286,  1290,  1301,  1300,  1381,  1381,
    1382,  1382,  1382,  1383,  1383,  1383,  1383,  1384,  1384,  1385,
    1386,  1386,  1388,  1394,  1400,  1406,  1417,  1423,  1429,  1440,
    1447,  1446,  1452,  1452,  1453,  1454,  1459,  1464,  1469,  1474,
    1479,  1484,  1489,  1494,  1499,  1504,  1509,  1516,  1515,  1521,
    1521,  1523,  1528,  1533,  1538,  1543,  1548,  1553,  1558,  1563,
    1568,  1573,  1578,  1583,  1590,  1589,  1595,  1595,  1596,  1600,
    1604,  1608,  1612,  1616,  1620,  1624,  1628,  1632,  1636,  1640,
    1644,  1648,  1652,  1656,  1660,  1664,  1668,  1672,  1676,  1680,
    1684,  1688,  1692,  1696,  1700,  1711,  1710,  1769,  1769,  1770,
    1771,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1780,  1780,  1780,  1780,  1781,  1782,  1783,  1784,  1786,
    1792,  1798,  1804,  1810,  1816,  1822,  1828,  1834,  1840,  1846,
    1852,  1858,  1865,  1871,  1877,  1883,  1892,  1902,  1901,  1907,
    1907,  1908,  1912,  1923,  1922,  1929,  1928,  1934,  1934,  1935,
    1939,  1943,  1947,  1951,  1957,  1957,  1958,  1958,  1958,  1958,
    1958,  1958,  1961,  1960,  1966,  1966,  1968,  1987,  2010,  2016,
    2022,  2032,  2031,  2096,  2096,  2097,  2097,  2097,  2097,  2098,
    2098,  2098,  2099,  2099,  2100,  2100,  2102,  2108,  2114,  2120,
    2132,  2131,  2137,  2137,  2138,  2142,  2146,  2150,  2154,  2158,
    2162,  2166,  2170,  2174,  2178,  2182,  2188,  2202,  2211,  2220,
    2228,  2241,  2240,  2255,  2255,  2256,  2256,  2256,  2256,  2258,
    2264,  2270,  2280,  2282,  2282,  2283,  2283,  2285,  2301,  2300,
    2325,  2325,  2326,  2326,  2326,  2326,  2328,  2334,  2354,  2353,
    2359,  2359,  2360,  2364,  2368,  2372,  2376,  2380,  2384,  2388,
    2392,  2396,  2406,  2405,  2426,  2426,  2427,  2427,  2427,  2429,
    2436,  2435,  2441,  2441,  2442,  2446,  2450,  2454,  2458,  2462,
    2466,  2470,  2474,  2478,  2488,  2487,  2574,  2574,  2575,  2575,
    2575,  2576,  2576,  2577,  2577,  2577,  2578,  2578,  2579,  2579,
    2579,  2580,  2580,  2581,  2583,  2589,  2595,  2601,  2614,  2627,
    2633,  2639,  2645,  2651,  2655,  2664,  2663,  2668,  2668,  2669,
    2673,  2679,  2690,  2696,  2702,  2713,  2712,  2738,  2738,  2739,
    2739,  2739,  2741,  2761,  2771,  2770,  2797,  2797,  2798,  2798,
    2798,  2800,  2806,  2815,  2817,  2817,  2818,  2818,  2820,  2838,
    2837,  2860,  2860,  2861,  2861,  2861,  2863,  2869,  2878,  2881,
    2881,  2882,  2882,  2883,  2883,  2884,  2884,  2885,  2885,  2886,
    2886,  2887,  2888,  2889,  2889,  2890,  2890,  2891,  2891,  2891,
    2892,  2892,  2893,  2894,  2894,  2895,  2896,  2896,  2897,  2897,
    2897,  2898,  2898,  2899,  2899,  2900,  2900,  2900,  2901,  2901,
    2902,  2903,  2903,  2904,  2904,  2905,  2906,  2907,  2908,  2909,
    2909,  2909,  2910,  2911,  2911,  2911,  2911,  2912,  2912,  2912,
    2913,  2913,  2913,  2914,  2917,  2922,  2928,  2937,  2946,  2955,
    2961,  2967,  2973,  2979,  2985,  2990,  2995,  3004,  3009,  3014,
    3019,  3024,  3029,  3034,  3039,  3044,  3049,  3054,  3059,  3065,
    3076,  3081,  3086,  3091,  3096,  3101,  3106,  3109,  3114,  3117,
    3122,  3127,  3132,  3137,  3142,  3147,  3152,  3157,  3162,  3167,
    3172,  3181,  3190,  3195,  3200,  3205,  3210,  3216,  3215,  3220,
    3225,  3230,  3242,  3242,  3243,  3247,  3251,  3255,  3259,  3263,
    3267,  3271,  3275,  3279,  3283,  3287,  3293,  3292,  3297,  3297,
    3299,  3303,  3307,  3311,  3315,  3319,  3323,  3327,  3331,  3335,
    3339,  3343,  3347,  3353,  3352,  3357,  3357,  3358,  3362,  3366,
    3370,  3374,  3378,  3382,  3386,  3390,  3394,  3398,  3402,  3407,
    3416,  3421,  3426,  3431,  3440,  3443,  3443,  3444,  3445,  3445,
    3446,  3446,  3447,  3448,  3449,  3450,  3451,  3451,  3452,  3452,
    3453,  3453,  3455,  3460,  3465,  3470,  3475,  3480,  3485,  3490,
    3495,  3500,  3505,  3510,  3515,  3520,  3528,  3531,  3531,  3532,
    3532,  3533,  3534,  3535,  3536,  3536,  3537,  3538,  3540,  3546,
    3552,  3558,  3564,  3573,  3587,  3593
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCEPT_PASSWORD", "ACCOUNT_WHOIS",
  "ADMIN", "AFTYPE", "ANTI_NICK_FLOOD", "ANTI_SPAM_EXIT_MESSAGE_TIME",
  "AUTOCONN", "BYTES", "KBYTES", "MBYTES", "CA_FILE", "CALLER_ID_WAIT",
  "CAN_FLOOD", "CHANNEL", "CIDR_BITLEN_IPV4", "CIDR_BITLEN_IPV6",
  "CIPHER_LIST", "CLASS", "CLOAK_KEY1", "CLOAK_KEY2", "CLOAK_KEY3",
  "CLOAK_WHOIS_ACTUALLY", "CONNECT", "CONNECTFREQ", "CYCLE_ON_HOST_CHANGE",
  "DEFAULT_FLOODCOUNT", "DEFAULT_SPLIT_SERVER_COUNT",
  "DEFAULT_SPLIT_USER_COUNT", "DEFER", "DENY", "DESCRIPTION", "DIE",
  "DISABLE_AUTH", "DISABLE_CHMODES", "DISABLE_FAKE_CHANNELS",
  "DISABLE_REMOTE_COMMANDS", "DNSBL", "DNSBL_EXEMPT", "DOTS_IN_IDENT",
  "DURATION", "EMAIL", "ENABLE_EXTBANS", "ENABLE_FORWARDING", "ENCRYPTED",
  "EXCEED_LIMIT", "EXEMPT", "FAILED_OPER_NOTICE", "FLATTEN_LINKS",
  "FLOOD_BURST", "FLOOD_LIMIT", "GECOS", "GENERAL", "GLINE",
  "GLINE_DURATION", "GLINE_ENABLE", "GLINE_EXEMPT", "GLINE_MIN_CIDR",
  "GLINE_MIN_CIDR6", "GLINE_REQUEST_DURATION", "HAVENT_READ_CONF",
  "HIDDEN", "HIDDEN_NAME", "HIDE_IDLE_FROM_OPERS", "HIDE_SERVER_IPS",
  "HIDE_SERVERS", "HIDE_SERVICES", "HIDE_SPOOF_IPS", "HOST", "HTTP", "HUB",
  "HUB_MASK", "IDENTITY", "IGNORE_BOGUS_TS", "INVISIBLE_ON_CONNECT",
  "INVITE_THROTTLE", "IP", "IRCD_AUTH", "IRCD_FLAGS", "IRCD_SID",
  "JOIN_FLOOD_COUNT", "JOIN_FLOOD_TIME", "KILL", "KILL_CHASE_TIME_LIMIT",
  "KLINE", "KLINE_EXEMPT", "KLINE_REASON", "KNOCK_DELAY",
  "KNOCK_DELAY_CHANNEL", "LEAF_MASK", "T_LINK", "LINKS_DELAY", "LISTEN",
  "MASK", "MATCH", "MAX_ACCEPT", "MAX_BANS", "MAX_CHANS_PER_OPER",
  "MAX_CHANS_PER_USER", "MAX_GLOBAL", "MAX_IDENT", "MAX_IDLE", "MAX_LOCAL",
  "MAX_NICK_CHANGES", "MAX_NICK_LENGTH", "MAX_NICK_TIME", "MAX_NUMBER",
  "MAX_TARGETS", "MAX_TOPIC_LENGTH", "MAX_WATCH", "MIN_IDLE",
  "MIN_NONWILDCARD", "MIN_NONWILDCARD_SIMPLE", "MODULE", "MODULES", "MOTD",
  "NAME", "NEED_ACCOUNT", "NEED_IDENT", "NEED_PASSWORD", "NETWORK_DESC",
  "NETWORK_NAME", "NICK", "NICK_COLLIDE_REALHOST", "NO_CREATE_ON_SPLIT",
  "NO_JOIN_ON_SPLIT", "NO_OPER_FLOOD", "NO_TILDE", "NUMBER",
  "NUMBER_PER_CIDR", "NUMBER_PER_IP", "OPER_ONLY", "OPER_ONLY_UMODES",
  "OPER_PASS_RESV", "OPER_SNOMASKS", "OPER_UMODES", "OPERATOR",
  "OPERS_BYPASS_CALLERID", "PACE_WAIT", "PACE_WAIT_SIMPLE", "PASSWORD",
  "PATH", "PING_COOKIE", "PING_TIME", "PORT", "QSTRING", "QUIET_ON_BAN",
  "RANDOM_IDLE", "REASON", "REDIRPORT", "REDIRSERV", "REHASH", "REMOTE",
  "REMOTEBAN", "RESV", "RESV_EXEMPT", "RSA_PRIVATE_KEY_FILE",
  "RSA_PUBLIC_KEY_FILE", "SCRIPT", "SECONDS", "MINUTES", "HOURS", "DAYS",
  "WEEKS", "MONTHS", "YEARS", "SEND_PASSWORD", "SENDQ", "SERVERHIDE",
  "SERVERINFO", "SERVER_NAME", "SHORT_MOTD", "T_SNOMASKS", "SOFT_SENDQ",
  "SPOOF", "SPOOF_NOTICE", "SQUIT", "SSL_CERTIFICATE_FILE",
  "SSL_CERTIFICATE_FINGERPRINT", "SSL_CONNECTION_REQUIRED",
  "SSL_DH_ELLIPTIC_CURVE", "SSL_DH_PARAM_FILE",
  "SSL_MESSAGE_DIGEST_ALGORITHM", "STATS_E_DISABLED", "STATS_I_OPER_ONLY",
  "STATS_K_OPER_ONLY", "STATS_M_OPER_ONLY", "STATS_O_OPER_ONLY",
  "STATS_P_OPER_ONLY", "STATS_U_OPER_ONLY", "T_ALIAS", "T_ALL", "T_BOTS",
  "T_CALLERID", "T_CCONN", "T_CLUSTER", "T_DEAF", "T_DEBUG", "T_DLINE",
  "T_FARCONNECT", "T_FILE", "T_FULL", "T_HIDECHANNELS", "T_GLOBOPS",
  "T_INVISIBLE", "T_IPV4", "T_IPV6", "T_LOCOPS", "T_LOG", "T_MAX_CLIENTS",
  "T_NCHANGE", "T_NOCTCP", "T_NONONREG", "T_OPERWALL", "T_RECVQ", "T_REJ",
  "T_RESTART", "T_SASL_NAME", "T_SERVER", "T_SERVICE", "T_SERVICES_NAME",
  "T_SERVNOTICE", "T_SET", "T_SHARED", "T_SIZE", "T_SKILL",
  "T_SOFTCALLERID", "T_SPY", "T_SSL", "SSLPROFILE", "SSL_PROFILE",
  "T_UMODES", "T_UNAUTH", "T_UNDLINE", "T_UNLIMITED", "T_UNRESV",
  "T_UNXLINE", "T_WALLOP", "T_WALLOPS", "T_WALLUSERS", "T_WEBIRC", "TBOOL",
  "THROTTLE_NUM", "THROTTLE_TIME", "TKLINE_EXPIRE_NOTICES", "TMASKED",
  "TS_MAX_DELTA", "TS_WARN_DELTA", "TWODOTS", "TYPE", "UNKLINE",
  "USE_LOGGING", "USE_TARGET_CHANGE", "USER", "VHOST", "VHOST6",
  "WARN_NO_NLINE", "XLINE", "';'", "'}'", "'{'", "'='", "','", "':'",
  "$accept", "conf", "conf_item", "timespec_", "timespec", "sizespec_",
  "sizespec", "alias_entry", "$@1", "alias_items", "alias_item",
  "alias_name", "alias_user", "alias_host", "alias_oper_only",
  "modules_entry", "modules_items", "modules_item", "modules_module",
  "modules_script", "modules_path", "sslprofile", "$@2",
  "sslprofile_items", "sslprofile_item", "sslprofile_name",
  "sslprofile_dh_param_file", "sslprofile_dh_elliptic_curve",
  "sslprofile_cipher_list", "sslprofile_cafile", "sslprofile_identity",
  "$@3", "sslprofile_identity_items", "sslprofile_identity_item",
  "sslprofile_identity_server_name",
  "sslprofile_identity_rsa_private_key_file",
  "sslprofile_identity_certificate_file", "serverinfo_entry",
  "serverinfo_items", "serverinfo_item", "serverinfo_name",
  "serverinfo_sid", "serverinfo_description", "serverinfo_network_name",
  "serverinfo_network_desc", "serverinfo_vhost", "serverinfo_vhost6",
  "serverinfo_max_clients", "serverinfo_max_nick_length",
  "serverinfo_max_topic_length", "serverinfo_hub", "admin_entry",
  "admin_items", "admin_item", "admin_name", "admin_email",
  "admin_description", "motd_entry", "$@4", "motd_items", "motd_item",
  "motd_mask", "motd_file", "dnsbl_entry", "$@5", "dnsbl_items",
  "dnsbl_item", "dnsbl_name", "dnsbl_reason", "dnsbl_matches",
  "match_items", "match_item", "logging_entry", "logging_items",
  "logging_item", "logging_use_logging", "logging_file_entry", "$@6",
  "logging_file_items", "logging_file_item", "logging_file_name",
  "logging_file_size", "logging_file_type", "$@7",
  "logging_file_type_items", "logging_file_type_item", "oper_entry", "$@8",
  "oper_items", "oper_item", "oper_name", "oper_user", "oper_password",
  "oper_encrypted", "oper_rsa_public_key_file",
  "oper_ssl_certificate_fingerprint", "oper_ssl_connection_required",
  "oper_class", "oper_umodes", "$@9", "oper_umodes_items",
  "oper_umodes_item", "oper_snomasks", "$@10", "oper_snomasks_items",
  "oper_snomasks_item", "oper_flags", "$@11", "oper_flags_items",
  "oper_flags_item", "class_entry", "$@12", "class_items", "class_item",
  "class_name", "class_ping_time", "class_number_per_ip",
  "class_connectfreq", "class_max_number", "class_max_global",
  "class_max_local", "class_max_ident", "class_soft_sendq",
  "class_flood_burst", "class_flood_limit", "class_sendq", "class_recvq",
  "class_cidr_bitlen_ipv4", "class_cidr_bitlen_ipv6",
  "class_number_per_cidr", "class_min_idle", "class_max_idle",
  "class_flags", "$@13", "class_flags_items", "class_flags_item",
  "listen_entry", "$@14", "listen_flags", "$@15", "listen_flags_items",
  "listen_flags_item", "listen_items", "listen_item", "listen_port",
  "$@16", "port_items", "port_item", "listen_address", "listen_host",
  "listen_ssl_profile", "auth_entry", "$@17", "auth_items", "auth_item",
  "auth_user", "auth_passwd", "auth_class", "auth_encrypted", "auth_flags",
  "$@18", "auth_flags_items", "auth_flags_item", "auth_spoof",
  "auth_redir_serv", "auth_redir_port", "auth_ssl_certificate_fingerprint",
  "auth_ca_file", "resv_entry", "$@19", "resv_items", "resv_item",
  "resv_mask", "resv_reason", "resv_exempt", "service_entry",
  "service_items", "service_item", "service_name", "shared_entry", "$@20",
  "shared_items", "shared_item", "shared_name", "shared_user",
  "shared_type", "$@21", "shared_types", "shared_type_item",
  "cluster_entry", "$@22", "cluster_items", "cluster_item", "cluster_name",
  "cluster_type", "$@23", "cluster_types", "cluster_type_item",
  "connect_entry", "$@24", "connect_items", "connect_item", "connect_name",
  "connect_host", "connect_vhost", "connect_send_password",
  "connect_accept_password", "connect_ssl_certificate_fingerprint",
  "connect_ca_file", "connect_ssl_profile", "connect_port",
  "connect_aftype", "connect_flags", "$@25", "connect_flags_items",
  "connect_flags_item", "connect_encrypted", "connect_hub_mask",
  "connect_leaf_mask", "connect_class", "kill_entry", "$@26", "kill_items",
  "kill_item", "kill_user", "kill_reason", "deny_entry", "$@27",
  "deny_items", "deny_item", "deny_ip", "deny_reason", "exempt_entry",
  "exempt_items", "exempt_item", "exempt_ip", "gecos_entry", "$@28",
  "gecos_items", "gecos_item", "gecos_name", "gecos_reason",
  "general_entry", "general_items", "general_item", "general_max_watch",
  "general_cycle_on_host_change", "general_cloak_key1",
  "general_cloak_key2", "general_cloak_key3",
  "general_cloak_whois_actually", "general_account_whois",
  "general_gline_enable", "general_gline_duration",
  "general_gline_request_duration", "general_gline_min_cidr",
  "general_gline_min_cidr6", "general_kline_reason",
  "general_tkline_expire_notices", "general_kill_chase_time_limit",
  "general_hide_spoof_ips", "general_ignore_bogus_ts",
  "general_failed_oper_notice", "general_anti_nick_flood",
  "general_max_nick_time", "general_max_nick_changes",
  "general_max_accept", "general_anti_spam_exit_message_time",
  "general_ts_warn_delta", "general_ts_max_delta",
  "general_havent_read_conf", "general_invisible_on_connect",
  "general_warn_no_nline", "general_stats_e_disabled",
  "general_stats_o_oper_only", "general_stats_P_oper_only",
  "general_stats_u_oper_only", "general_stats_k_oper_only",
  "general_stats_i_oper_only", "general_stats_m_oper_only",
  "general_pace_wait", "general_caller_id_wait",
  "general_opers_bypass_callerid", "general_pace_wait_simple",
  "general_short_motd", "general_no_oper_flood", "general_oper_pass_resv",
  "general_dots_in_ident", "general_max_targets", "general_services_name",
  "general_sasl_name", "general_ping_cookie",
  "general_nick_collide_realhost", "general_disable_auth",
  "general_throttle_num", "general_throttle_time", "general_oper_umodes",
  "$@29", "general_enable_extbans", "general_enable_forwarding",
  "general_ssl_message_digest_algorithm", "umode_oitems", "umode_oitem",
  "general_oper_snomasks", "$@30", "snomask_oitems", "snomask_oitem",
  "general_oper_only_umodes", "$@31", "umode_items", "umode_item",
  "general_disable_chmodes", "general_use_target_change",
  "general_min_nonwildcard", "general_min_nonwildcard_simple",
  "general_default_floodcount", "channel_entry", "channel_items",
  "channel_item", "channel_disable_fake_channels", "channel_knock_delay",
  "channel_knock_delay_channel", "channel_max_chans_per_user",
  "channel_max_chans_per_oper", "channel_max_bans",
  "channel_default_split_user_count", "channel_default_split_server_count",
  "channel_no_create_on_split", "channel_no_join_on_split",
  "channel_jflood_count", "channel_jflood_time", "channel_quiet_on_ban",
  "channel_invite_throttle", "serverhide_entry", "serverhide_items",
  "serverhide_item", "serverhide_flatten_links",
  "serverhide_disable_remote_commands", "serverhide_hide_servers",
  "serverhide_hide_services", "serverhide_hidden_name",
  "serverhide_links_delay", "serverhide_hidden",
  "serverhide_hide_server_ips", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
      59,   125,   123,    61,    44,    58
};
# endif

#define YYPACT_NINF -805

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-805)))

#define YYTABLE_NINF -163

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -805,   723,  -805,  -228,  -242,  -232,  -805,  -805,  -805,  -805,
    -227,  -805,  -218,  -805,  -805,  -805,  -213,  -805,  -805,  -805,
    -207,  -205,  -805,  -805,  -193,  -192,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,   345,   705,  -176,  -174,  -163,
    -146,    27,  -137,   471,  -116,  -114,   -84,   297,   -82,   -81,
     -76,   924,   416,   -70,   -49,    33,     9,   -42,   -11,     6,
    -237,    16,    34,    52,  -805,  -805,  -805,  -805,  -805,    58,
      69,    76,    82,    89,    90,   105,   107,   122,   130,   135,
     136,   141,   144,   210,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,   796,
     618,    26,   232,  -805,   147,    14,  -805,  -805,   193,  -805,
     153,   155,   157,   162,   163,   164,   166,   168,   170,   171,
     172,   173,   175,   179,   181,   183,   184,   185,   187,   188,
     189,   191,   195,   196,   197,   199,   205,   207,   217,   218,
     219,   221,   223,   224,   237,   238,  -805,   239,  -805,  -805,
     245,   246,   250,   251,   254,   255,   256,   258,   260,   261,
     262,   266,   278,   280,   281,   282,   285,   286,   287,   288,
     292,   298,    15,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,   490,    10,   396,    18,
     299,   300,   302,    23,  -805,  -805,  -805,  -805,   190,   393,
     306,  -805,   308,   309,   312,   314,   316,   318,   320,   323,
      30,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
      43,   325,   334,   335,   338,   339,   340,   341,   346,   350,
     351,   354,   208,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,   186,   106,   360,   359,    81,
    -805,  -805,  -805,    88,  -805,   362,   110,  -805,  -805,   108,
     371,  -805,   283,   422,   453,   363,  -805,   499,   500,   390,
     504,   505,   504,   504,   504,   506,   507,   509,   397,   400,
     402,   386,  -805,   389,   387,   388,   404,   405,   406,  -805,
     408,   412,   414,   415,   417,   418,   419,   420,   421,   426,
     429,   431,   432,   113,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,   392,   433,   444,   445,   448,   449,
     450,   451,  -805,   455,   458,   459,   464,   467,   468,   475,
     176,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,   477,   486,
      11,  -805,  -805,  -805,   403,   488,   489,   491,    77,  -805,
    -805,  -805,  -805,   518,   497,  -805,  -805,   498,   502,   100,
    -805,  -805,  -805,   410,   520,   504,   504,   619,   622,   627,
     535,   536,   645,   537,   634,   655,   546,   549,   550,   504,
     557,   671,   676,   504,   678,   566,   567,   568,   504,   668,
     688,   689,   504,   690,   691,   693,   694,   583,   586,   570,
     587,   571,   573,   594,   504,   504,   595,   598,   696,   601,
    -234,  -222,   602,   603,   608,   609,   707,   709,   728,   504,
     616,   504,   504,   620,   623,   605,  -805,   607,   599,   606,
     612,  -805,   614,   617,   621,   624,   626,   628,   235,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,   629,   633,    80,  -805,  -805,  -805,   610,   638,   640,
    -805,   642,   643,  -805,    64,  -805,  -805,  -805,  -805,  -805,
    -805,   721,   724,   725,   625,  -805,   647,   646,   648,   167,
    -805,  -805,  -805,   650,   649,   653,  -805,   654,   658,   659,
    -805,   660,   666,  -805,   667,   222,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,   664,   669,
     673,   675,    13,  -805,  -805,  -805,  -805,   670,   697,   700,
     736,   702,   704,   706,   504,   674,  -805,  -805,   739,   708,
     755,   788,   801,   803,   805,   806,   826,   810,   811,   699,
    -805,   713,   703,   712,   716,   717,    51,  -805,  -805,  -805,
    -805,  -805,   722,   718,  -805,   114,  -805,  -805,  -805,  -805,
     733,   734,  -805,   731,   820,   738,  -805,   741,   720,  -805,
     740,    72,  -805,  -805,  -805,  -805,   742,   745,   746,  -805,
     748,   750,   752,   134,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,   762,   763,   764,  -805,   769,   772,   773,   428,   774,
     776,   778,   783,   784,   785,   789,   790,   792,   793,   794,
    -805,  -805,   838,   839,   504,   854,   866,   795,   869,   925,
     504,   927,   929,   504,   913,   933,   934,   504,   935,   935,
     935,   807,  -805,  -805,   919,  -161,   921,   922,   827,   926,
     928,   808,   930,   931,   944,   932,   936,   937,   938,   816,
    -805,   939,   940,   821,  -805,  -805,   941,   942,   943,   822,
    -805,   831,  -805,   945,   946,   834,  -805,   835,   836,   837,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   852,   853,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   867,   868,   870,   871,   872,
     873,   874,   875,   791,   876,   661,   812,   877,   878,   879,
     880,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,   899,
     900,  -805,  -805,   951,   952,   918,   817,   967,   996,   982,
    1015,  1016,  1017,   905,  -805,  1019,  1020,   908,  -805,  -805,
    1022,  1023,   909,  1041,  1026,   914,  -805,   915,   916,   917,
    -805,  -805,  1031,  1032,   920,  -805,  -805,  1034,   947,   923,
    1035,  1036,  1037,   948,  1038,   949,   950,  1040,   954,  -805,
    -805,  1042,  1044,  1046,   955,  -805,   956,   957,   958,   959,
     960,   961,   962,   963,  -805,   964,   965,   966,   968,   969,
     970,   971,   972,   973,   974,   975,  -805,  -805,  1047,   953,
    1048,  1050,   976,  -805,  -805,  1051,   977,   978,  -805,   979,
    -805,     3,   981,  -805,  -805,  1052,   980,  1053,   984,  -805,
    -805,  1054,  1055,   983,  1056,  1057,  1058,   986,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,   504,   504,   504,   504,   504,
     504,   504,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,   987,   988,   989,   990,   991,
     -47,   992,   993,   994,   995,   997,   998,   999,  1000,  1001,
    1002,   337,  1003,  1004,  1005,  -805,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,     8,  1014,  1018,  1021,  1024,  1025,
    1027,  1028,  -805,  1029,  1030,  -805,  -805,  -206,  -805,  1033,
    1039,  -805,  -805,  1043,  1045,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -198,  -805,  -805,  1049,  1059,  1060,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -197,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -177,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  1061,  1062,  1063,
     639,  1066,  1067,  1068,  1069,  1070,  1071,  -805,  1072,  1073,
    -805,  1074,  1075,   -23,   203,  1076,  -805,  1077,  -805,  -805,
    -805,  -805,  1078,  1079,  -805,  1081,  1082,   532,  1083,  1084,
    1085,   743,  1086,  1087,   833,  1088,  -805,  1089,  1090,  1091,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    1092,  1093,  1094,  1095,  -805,  1096,   590,  -805,  -805,  1097,
    1098,  1099,  -805,    44,  -805,  -805,  -805,  -805,  -805,  1100,
     726,  1103,  -805,  1104,  1105,   242,  1106,  1107,  1108,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -154,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,   935,   935,   935,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -147,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,   941,  -805,  -805,  -805,
    -805,  -805,   791,  1102,  1121,  1122,  -805,   661,  -805,   812,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -127,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,   -93,  -805,  1080,  1041,  1109,  -805,  -805,  -805,
    -805,  -805,  -805,  1110,  -805,  -805,  1111,  -805,  -805,  -805,
    -805,  1112,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,    -7,  -805,  -805,  -805,
    -805,  1113,  1114,  1115,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,    60,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,    91,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,   102,  -805,
    -805,  1065,   -51,  1118,  1123,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,   119,  -805,  -805,
    -805,  -805,  1124,  1119,  1125,  1126,    40,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,   -47,  -805,  -805,  -805,  -805,
       8,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,   639,
    -805,   -23,  -805,  -805,  -805,  1128,  1129,  1132,  -805,   532,
    1137,  1138,  1140,  -805,   743,  -805,   833,  -805,   590,  1127,
    1130,  1131,   305,  -805,  -805,   726,  -805,  1133,  1148,  1149,
    1134,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,   145,  -805,
    -805,  1135,  1136,  1139,  -805,  -805,   305,  -805,  -805,  -805,
    -805
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,   275,   454,   504,   141,
       0,   519,     0,   351,   495,   323,     0,   132,   186,   391,
       0,     0,    46,   432,     0,     0,   408,    69,     3,     5,
      24,    25,    12,     4,    26,    27,     6,     7,     9,    10,
      11,    14,    15,    16,    17,    18,    19,    20,    21,    23,
      22,     8,    13,    28,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   124,   125,   127,   126,   721,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   706,   718,   708,   709,   710,   711,
     707,   712,   713,   714,   715,   716,   717,   719,   720,     0,
       0,     0,     0,   517,     0,     0,   515,   516,     0,   593,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   683,     0,   666,   647,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   530,   579,   582,   583,   584,   585,   586,
     587,   572,   573,   574,   575,   576,   577,   571,   541,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   567,
     542,   543,   578,   545,   551,   552,   546,   548,   549,   547,
     560,   561,   550,   553,   554,   555,   544,   557,   580,   581,
     568,   569,   570,   565,   566,   558,   590,   591,   592,   559,
     556,   588,   589,   563,   564,   562,     0,     0,     0,     0,
       0,     0,     0,     0,    61,    62,    63,    64,     0,     0,
       0,   747,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   738,   739,   740,   741,   742,   745,   743,   744,   746,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    98,    99,   109,   102,   103,   104,   100,
     108,   105,   106,   107,   101,     0,     0,     0,     0,     0,
     157,   158,   159,     0,   406,     0,     0,   404,   405,     0,
       0,   128,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   705,     0,     0,     0,     0,     0,     0,   317,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   278,   279,   282,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   280,   281,
     283,   295,   296,   297,     0,     0,     0,     0,     0,     0,
       0,     0,   485,     0,     0,     0,     0,     0,     0,     0,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     467,   466,   468,   472,   469,   470,   471,   510,     0,     0,
       0,   507,   508,   509,     0,     0,     0,     0,     0,   144,
     145,   146,   147,     0,     0,   514,   525,     0,     0,     0,
     522,   523,   524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   529,     0,     0,     0,
       0,   370,     0,     0,     0,     0,     0,     0,     0,   354,
     355,   356,   357,   362,   358,   359,   360,   361,   363,   364,
     501,     0,     0,     0,   498,   499,   500,     0,     0,     0,
     325,     0,     0,   337,     0,   335,   336,   338,   339,   340,
      65,     0,     0,     0,     0,    60,     0,     0,     0,     0,
     135,   136,   137,     0,     0,     0,   244,     0,     0,     0,
     227,     0,     0,   210,     0,     0,   189,   190,   191,   192,
     196,   197,   198,   199,   195,   193,   194,   200,     0,     0,
       0,     0,     0,   394,   395,   396,   397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   737,   110,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      97,     0,     0,     0,     0,     0,     0,    49,    50,    51,
      52,    53,     0,     0,   440,     0,   435,   436,   437,   160,
       0,     0,   156,     0,     0,     0,   403,     0,     0,   418,
       0,     0,   411,   412,   413,   414,     0,     0,     0,    85,
       0,     0,     0,     0,    72,    73,    74,    75,    76,    77,
      78,     0,     0,     0,   122,     0,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     704,   298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   277,   473,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     456,     0,     0,     0,   506,   148,     0,     0,     0,     0,
     143,     0,   513,     0,     0,     0,   521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   528,   365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   353,     0,     0,     0,   497,   341,
       0,     0,     0,     0,     0,     0,   334,     0,     0,     0,
      59,   138,     0,     0,     0,   134,   201,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   188,
     398,     0,     0,     0,     0,   393,     0,     0,     0,     0,
       0,     0,     0,     0,   736,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    96,    54,     0,     0,
       0,     0,     0,    48,   438,     0,     0,     0,   434,     0,
     155,     0,     0,   402,   415,     0,     0,     0,     0,   410,
      79,     0,     0,     0,     0,     0,     0,     0,    71,   131,
     130,   129,   729,   728,   722,    30,    30,    30,    30,    30,
      30,    30,    32,    31,   735,   732,   733,   723,   724,   727,
     726,   725,   730,   731,   734,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,     0,   276,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   455,     0,     0,   505,   154,     0,   153,     0,
       0,   142,   518,     0,     0,   520,   600,   612,   616,   632,
     596,   597,   598,   599,   595,   703,   644,   699,   638,   649,
     650,   611,   602,   601,   604,   605,   603,   619,   609,   610,
     620,   608,   606,   615,   614,   613,   639,   594,   701,   702,
     643,   636,   695,   688,   689,   692,   696,   687,   697,   690,
     691,   694,   698,   693,     0,   686,   637,   682,   671,   673,
     674,   676,   675,   678,   677,   680,   679,     0,   669,   662,
     655,   656,   659,   663,   654,   664,   657,   658,   661,   665,
     660,     0,   653,   633,   631,   634,   642,   635,   651,   622,
     628,   629,   626,   627,   630,   623,   624,   625,   641,   640,
     645,   646,   607,   618,   617,   700,   621,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   352,     0,     0,
     496,     0,     0,     0,   346,   342,   345,     0,   324,    66,
      68,    67,     0,     0,   133,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   214,     0,   187,     0,     0,     0,
     392,   749,   748,   754,   752,   755,   750,   751,   753,   113,
     121,   112,   119,   120,   111,   115,   114,   118,   116,   117,
       0,     0,     0,     0,    47,     0,     0,   433,   161,     0,
       0,     0,   173,     0,   165,   166,   168,   167,   407,     0,
       0,     0,   409,     0,     0,     0,     0,     0,     0,    70,
      33,    34,    35,    36,    37,    38,    39,   312,   313,   302,
     308,   309,   322,   321,     0,   320,   304,   306,   316,   305,
     303,   315,   299,   314,   301,   300,    40,    40,    40,    42,
      41,   310,   307,   311,   478,   483,   484,   480,   494,   491,
     475,   492,   489,   490,     0,   488,   493,   474,   482,   477,
     479,   481,   476,   511,   512,   151,     0,   149,   150,   526,
     527,   684,     0,     0,     0,     0,   667,     0,   648,     0,
     390,   368,   369,   379,   377,   375,   381,   376,   384,   378,
     385,   380,   382,   374,   383,     0,   373,   367,   388,   387,
     386,   389,   366,   503,   502,   349,   348,   333,   330,   332,
     331,   329,     0,   328,     0,     0,     0,   350,   139,   140,
     209,   205,   266,   253,   263,   262,   251,   256,   274,   265,
     272,   255,   258,   249,   268,   271,   250,   267,   264,   273,
     259,   261,   269,   270,   257,   260,     0,   247,   202,   204,
     206,   243,   232,   234,   235,   236,   238,   239,   237,   241,
     240,     0,   230,   207,   208,   223,   216,   217,   220,   224,
     215,   225,   218,   219,   222,   226,   221,     0,   213,   203,
     401,   399,   400,    55,    58,    57,    56,   439,   444,   450,
     453,   446,   452,   447,   451,   449,   445,   448,     0,   443,
     169,     0,     0,     0,     0,   164,   416,   422,   428,   431,
     424,   430,   425,   429,   427,   423,   426,     0,   421,   417,
      84,    83,     0,     0,     0,     0,     0,    88,    89,    90,
      91,    80,    82,    81,   318,     0,    43,    44,    45,   486,
       0,   152,   685,   681,   670,   672,   668,   652,   371,     0,
     326,     0,   347,   344,   343,     0,     0,     0,   245,     0,
       0,     0,     0,   228,     0,   211,   214,   441,     0,     0,
       0,     0,     0,   163,   419,     0,    92,     0,     0,     0,
       0,    87,   319,   487,   372,   327,   252,   248,   254,   246,
     242,   231,   233,   229,   212,   442,   170,   172,   171,   179,
     184,   183,   178,   181,   185,   182,   177,   180,     0,   176,
     420,     0,     0,     0,    86,   174,     0,    94,    93,    95,
     175
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -805,  -805,  -805,  -236,  -337,  -804,  -718,  -805,  -805,  -805,
     552,  -805,  -805,  -805,  -805,  -805,  -805,  1141,  -805,  -805,
    -805,  -805,  -805,  -805,   533,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -209,  -805,  -805,  -805,  -805,  -805,   906,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  1144,  -805,  -805,  -805,  -805,  -805,  -805,
     710,  -805,  -805,  -805,  -805,  -805,   771,  -805,  -805,  -805,
    -805,   -19,  -805,  -805,   985,  -805,  -805,  -805,  -805,    59,
    -805,  -805,  -805,  -805,  -805,  -229,  -805,  -805,  -805,   715,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -159,  -805,  -805,  -805,  -156,  -805,  -805,  -805,  -148,
    -805,  -805,  -805,  1064,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -123,  -805,  -805,  -805,  -805,
    -805,  -135,  -805,   753,  -805,  -805,  -805,     4,  -805,  -805,
    -805,  -805,  -805,  -805,   780,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -129,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,   711,  -805,  -805,  -805,  -805,  -805,  1101,  -805,  -805,
    -805,  -805,   651,  -805,  -805,  -805,  -805,  -805,  -150,  -805,
    -805,  -805,   672,  -805,  -805,  -805,  -805,  -142,  -805,  -805,
    -805,   901,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -112,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,   777,  -805,  -805,  -805,  -805,  -805,  1116,
    -805,  -805,  -805,  -805,  1194,  -805,  -805,  -805,  -805,   910,
    -805,  -805,  -805,  -805,  1166,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,    67,  -805,  -805,  -805,   103,  -805,  -805,  -805,
     109,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  1269,  -805,
    -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805,  -805,  1117,  -805,  -805,  -805,  -805,
    -805,  -805,  -805,  -805
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    28,   942,   943,  1229,  1230,    29,    73,   636,
     637,   638,   639,   640,   641,    30,   263,   264,   265,   266,
     267,    31,    78,   673,   674,   675,   676,   677,   678,   679,
     680,   923,  1416,  1417,  1418,  1419,  1420,    32,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    33,    83,    84,    85,    86,    87,    34,    68,   569,
     570,   571,   572,    35,    60,   438,   439,   440,   441,   442,
     997,   998,    36,   319,   320,   321,   322,   323,  1183,  1184,
    1185,  1186,  1187,  1393,  1498,  1499,    37,    69,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   866,
    1367,  1368,   596,   863,  1351,  1352,   597,   859,  1336,  1337,
      38,    57,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   707,  1214,  1215,    39,    66,   553,   842,
    1302,  1303,   554,   555,   556,  1306,  1125,  1126,   557,   558,
     559,    40,    64,   528,   529,   530,   531,   532,   533,   534,
     826,  1285,  1286,   535,   536,   537,   538,   539,    41,    70,
     602,   603,   604,   605,   606,    42,   326,   327,   328,    43,
      77,   661,   662,   663,   664,   665,   916,  1407,  1408,    44,
      74,   645,   646,   647,   648,   906,  1388,  1389,    45,    58,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   731,  1244,  1245,   423,   424,   425,   426,
      46,    65,   543,   544,   545,   546,    47,    59,   430,   431,
     432,   433,    48,   125,   126,   127,    49,    62,   449,   450,
     451,   452,    50,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   492,   246,   247,
     248,  1081,  1082,   249,   491,  1067,  1068,   250,   489,  1054,
    1055,   251,   252,   253,   254,   255,    51,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    52,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     972,   973,   974,   689,  1179,   691,   692,   693,  1297,   804,
     324,   540,   427,   805,   598,   123,   129,  1242,  1212,   130,
      55,   806,   131,   132,   259,   807,   332,   427,   123,   133,
      56,   271,    53,    54,   317,    61,   134,   135,   136,   137,
    1298,  1412,   138,   139,    63,  1179,   977,   978,  1299,    67,
     140,   141,   631,    79,  1255,    71,   142,    72,  1256,   143,
     144,   599,  1261,  1266,   145,   547,  1262,  1267,   272,    75,
      76,   146,   147,   657,   148,   149,   150,   151,   434,   971,
     273,   540,   317,  1268,   152,    80,   119,  1269,   120,   428,
     153,   154,   124,   274,   275,    81,   276,   277,   278,   121,
     155,   446,  1213,   156,   428,   124,  1424,   642,   600,   657,
    1425,   324,   157,  1429,   353,   642,   122,  1430,   759,   760,
     158,  1180,   159,   279,   160,   128,   161,   325,   162,   163,
     354,   355,   773,  1438,   548,   666,   777,  1439,   260,   356,
     164,   782,   549,   165,   550,   786,   256,   667,   257,   166,
     167,   168,   169,   668,   170,   171,   172,   798,   799,   173,
     541,   429,  1180,   601,   357,   358,   261,  1440,   566,   632,
      82,  1441,   815,   435,   817,   818,   429,   394,   258,   395,
     268,   269,   396,   262,   633,  1460,   270,   631,   174,   397,
     658,   566,   315,   359,   446,   436,   398,  1300,  1413,   175,
     176,   177,   178,   179,   180,   181,   182,  1301,   669,   290,
     551,    88,  1414,   316,   360,   361,   362,   363,   447,  1415,
     329,   364,   399,   573,   643,   365,   658,   437,   325,  1181,
     541,   366,   643,   434,   183,  -162,   517,   184,  1243,    89,
      90,   291,   574,  1412,   367,   368,   400,    91,   518,   401,
     448,   330,   670,  1448,  1182,   519,   402,  1449,   369,   185,
     186,   187,   567,   188,   189,   542,   331,   403,   575,   190,
    1181,   634,   743,   191,   874,   444,   515,   883,   560,   333,
     292,   520,   370,  -162,   564,   567,   318,    92,   371,   293,
     653,   615,    93,    94,   404,  1182,   552,   334,   259,    95,
      96,  1470,   576,   617,   632,  1394,   635,   598,    97,    98,
      99,   447,   902,   335,   294,   521,   671,   672,   295,   633,
    1453,   337,   405,   659,  1454,   845,   296,   660,   435,   372,
     297,   298,   338,   918,   318,   542,   100,   101,   749,   339,
     577,   837,   651,   448,   406,   340,    79,  1226,  1227,  1228,
     436,  1455,   341,   342,   599,  1456,   407,   644,   102,   659,
    1489,   755,  1457,   660,   578,   644,  1458,   957,   343,   568,
     344,   655,   666,   963,   721,   907,   966,   522,    80,  1464,
     970,   579,   437,  1465,   667,   345,   523,   524,    81,  1490,
     668,  1491,   568,   346,   573,   927,   580,   547,   347,   348,
    1413,   600,   581,   582,   349,  1505,   634,   350,   408,  1506,
     443,   525,   260,   574,  1414,   526,   453,   290,   454,   299,
     455,  1415,  1426,  1427,  1428,   456,   457,   458,   854,   459,
     681,   460,   409,   461,   462,   463,   464,   739,   465,   575,
     261,   635,   466,  1492,   467,   669,   468,   469,   470,   291,
     471,   472,   473,  1304,   474,   583,   601,   262,   475,   476,
     477,  1493,   478,    82,   300,   301,   548,   971,   479,   629,
     480,   351,   129,   576,   549,   130,   550,   584,   131,   132,
     481,   482,   483,   868,   484,   133,   485,   486,   292,   670,
     527,   517,   134,   135,   136,   137,   833,   293,   138,   139,
     487,   488,   490,   518,  1494,  1495,   140,   141,   493,   494,
     519,   577,   142,   495,   496,   143,   144,   497,   498,   499,
     145,   500,   294,   501,   502,   503,   295,   146,   147,   504,
     148,   149,   150,   151,   296,   578,   520,  1312,   297,   298,
     152,   505,   551,   506,   507,   508,   153,   154,   509,   510,
     511,   512,   579,   671,   672,   513,   155,  1313,   688,   156,
    1496,   514,   561,   562,  1497,   563,  1314,   580,   157,   682,
     521,   607,   608,   581,   582,   609,   158,   610,   159,   611,
     160,   612,   161,   613,   162,   163,   614,  1315,   618,   935,
     936,   937,   938,   939,   940,   941,   164,   619,   620,   165,
     683,   621,   622,   623,   624,   166,   167,   168,   169,   625,
     170,   171,   172,   626,   627,   173,  1316,   628,  1317,   394,
     649,   395,   650,   684,   396,   654,   583,   299,   552,   685,
     686,   397,   522,   687,   688,   690,   694,   695,   398,   696,
     697,   523,   524,   698,   174,   699,   700,  1318,   584,   701,
     702,   703,   723,   757,  1273,   175,   176,   177,   178,   179,
     180,   181,   182,   745,   399,   751,   525,   704,   705,   706,
     526,   708,   300,   301,  1461,   709,  1378,   710,   711,  1274,
     712,   713,   714,   715,   716,  1319,  1275,  1320,   400,   717,
     183,   401,   718,   184,   719,   720,   724,  1276,   402,  1200,
    1201,  1202,  1203,  1204,  1205,  1206,    88,   725,   726,   403,
    1321,   727,   728,   729,   730,   185,   186,   187,   732,   188,
     189,   733,   734,     2,     3,   190,  1277,   735,     4,   191,
     736,   737,  1322,  1323,    89,    90,   404,  1324,   738,     5,
     741,  1325,    91,     6,  1326,   527,  1379,  1327,     7,   742,
    1328,   746,   747,  1057,   748,     8,  1329,   752,  1278,  1279,
    1280,   753,     9,   758,   405,   754,   761,  1330,  1281,   762,
    1331,    10,  1332,  1333,   763,   766,    11,    12,   764,   765,
     767,   768,    92,  1380,  1334,   769,   406,    93,    94,   770,
    1381,  1335,   771,   772,    95,    96,  1282,   353,   407,  1382,
     774,   775,    13,    97,    98,    99,   776,    14,   778,   779,
     780,   781,  1397,   354,   355,   783,  1283,    15,   784,   785,
     787,   788,   356,   789,   790,  1383,   791,  1384,  1385,   792,
     794,   100,   101,   793,   795,  1341,   796,   797,   800,    16,
      17,   801,  1386,   802,   803,   808,   809,   357,   358,  1387,
     408,   810,   811,   102,   812,  1058,   813,  1059,   814,   816,
    1060,    18,   823,   819,  1061,   821,   820,   822,   847,   824,
     839,   848,   849,  1062,   409,   825,   359,   827,  1063,    19,
     828,  1284,  1398,   879,   829,   850,   885,   830,  1064,   831,
    1065,   832,   835,    20,    21,  1066,   836,   360,   361,   362,
     363,   840,   887,   841,   364,   843,   844,   851,   365,   852,
     856,   853,   857,   876,   366,    22,   858,   860,   888,  1399,
      23,   861,   862,   864,   870,   271,  1400,   367,   368,   865,
     867,   889,   871,    24,   884,  1401,   872,  1342,   873,  1343,
     877,   369,  1344,   878,    25,   880,  1345,   881,    26,   882,
     890,   886,   891,   892,    27,  1346,   893,   894,   895,   896,
    1347,  1402,   272,  1403,  1404,   370,   898,   912,   955,   956,
    1348,   371,  1349,   897,   273,   899,   909,  1350,  1405,   900,
     901,   905,   904,   915,   958,  1406,  1042,   274,   275,  1043,
     276,   277,   278,   911,   910,  1044,   959,  1045,   913,   961,
    1046,   914,   920,   917,  1047,  1048,  1049,  1069,   921,   922,
    1070,   924,   372,   925,  1050,   926,  1071,   279,  1072,  1051,
    1052,  1073,   929,   930,   931,  1074,  1075,  1076,  1355,   932,
    1053,  1356,   933,   934,   944,  1077,   945,  1357,   946,  1358,
    1078,  1079,  1359,   947,   948,   949,  1360,  1361,  1362,   950,
     951,  1080,   952,   953,   954,   962,  1363,   964,   960,   965,
     967,  1364,  1365,   968,   969,   971,   976,   975,   979,   980,
     981,   984,  1366,   982,   987,   983,   992,   985,   986,   988,
    1110,   995,  1001,   989,   990,   991,   993,   994,   996,   999,
    1000,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1107,  1108,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1111,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1112,  1034,  1035,  1113,
    1036,  1037,  1038,  1039,  1040,  1041,  1056,  1083,  1084,  1085,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,
    1106,  1109,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1124,  1123,  1127,  1128,  1129,  1130,  1131,  1132,  1133,
    1134,  1135,  1138,  1139,  1140,  1142,  1137,  1145,   903,  1147,
    1136,  1148,  1143,  1149,  1170,  1172,  1171,  1173,  1175,  1189,
    1191,  1193,  1194,  1196,  1197,  1198,   928,  1471,   630,   750,
    1442,  1141,  1459,  1144,  1146,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,   336,  1162,  1163,
    1164,  1165,  1166,  1167,  1168,  1169,  1174,  1431,  1177,  1178,
    1176,  1188,  1395,  1190,  1192,  1195,  1199,  1207,  1208,  1209,
    1210,  1211,  1216,  1217,  1218,  1219,  1433,  1220,  1221,  1222,
    1223,  1224,  1225,  1231,  1232,  1233,  1234,  1235,  1236,  1237,
    1238,  1239,  1240,  1241,  1246,  1434,  1435,  1510,  1247,   855,
    1501,  1248,  1476,  1477,  1249,  1250,  1478,  1251,  1252,  1253,
    1254,  1480,  1481,  1257,  1482,  1502,  1503,  1484,  1483,  1258,
     869,  1479,  1472,  1259,   652,  1260,  1475,   846,   834,  1443,
    1474,   740,   919,   875,  1263,  1500,  1485,   908,  1473,   445,
     838,  1270,  1271,  1272,  1264,  1265,  1287,  1288,  1289,  1290,
    1291,  1292,  1293,  1294,  1295,  1296,  1437,  1307,  1308,  1309,
    1305,  1310,  1311,  1338,  1339,  1340,  1353,  1354,  1369,  1370,
    1371,  1372,  1373,  1374,  1375,  1376,  1377,  1390,   516,   756,
    1396,  1391,  1392,  1409,  1410,  1411,  1421,  1422,  1423,  1444,
    1436,  1432,   352,     0,     0,  1445,  1446,  1447,  1450,  1451,
    1452,  1462,  1467,  1463,  1466,     0,     0,  1486,  1468,  1469,
    1487,  1488,     0,     0,  1504,  1507,  1508,   616,     0,  1509,
       0,     0,     0,     0,   565,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   722,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   744
};

static const yytype_int16 yycheck[] =
{
     718,   719,   720,   340,     1,   342,   343,   344,    31,   243,
       1,     1,     1,   247,     1,     1,     1,     9,    65,     4,
     262,   243,     7,     8,     1,   247,   263,     1,     1,    14,
     262,     1,   260,   261,     1,   262,    21,    22,    23,    24,
      63,     1,    27,    28,   262,     1,   207,   208,    71,   262,
      35,    36,     1,     1,   260,   262,    41,   262,   264,    44,
      45,    48,   260,   260,    49,     1,   264,   264,    38,   262,
     262,    56,    57,     1,    59,    60,    61,    62,     1,   130,
      50,     1,     1,   260,    69,    33,   262,   264,   262,    78,
      75,    76,    78,    63,    64,    43,    66,    67,    68,   262,
      85,     1,   149,    88,    78,    78,   260,     1,    95,     1,
     264,     1,    97,   260,     1,     1,   262,   264,   455,   456,
     105,   118,   107,    93,   109,   262,   111,   118,   113,   114,
      17,    18,   469,   260,    70,     1,   473,   264,   115,    26,
     125,   478,    78,   128,    80,   482,   262,    13,   262,   134,
     135,   136,   137,    19,   139,   140,   141,   494,   495,   144,
     150,   150,   118,   150,    51,    52,   143,   260,     1,   118,
     118,   264,   509,    96,   511,   512,   150,     1,   262,     3,
     262,   262,     6,   160,   133,   236,   262,     1,   173,    13,
     118,     1,   262,    80,     1,   118,    20,   220,   158,   184,
     185,   186,   187,   188,   189,   190,   191,   230,    74,     1,
     146,     1,   172,   262,   101,   102,   103,   104,   118,   179,
     262,   108,    46,     1,   118,   112,   118,   150,   118,   226,
     150,   118,   118,     1,   219,   202,     1,   222,   230,    29,
      30,    33,    20,     1,   131,   132,    70,    37,    13,    73,
     150,   262,   118,   260,   251,    20,    80,   264,   145,   244,
     245,   246,    95,   248,   249,   255,   260,    91,    46,   254,
     226,   220,   261,   258,   261,   261,   261,   614,   260,   263,
      72,    46,   169,   202,   261,    95,   253,    77,   175,    81,
     202,   261,    82,    83,   118,   251,   232,   263,     1,    89,
      90,   261,    80,   260,   118,   261,   255,     1,    98,    99,
     100,   118,   261,   261,   106,    80,   182,   183,   110,   133,
     260,   263,   146,   251,   264,   261,   118,   255,    96,   216,
     122,   123,   263,   261,   253,   255,   126,   127,   261,   263,
     118,   261,   261,   150,   168,   263,     1,    10,    11,    12,
     118,   260,   263,   263,    48,   264,   180,   251,   148,   251,
      55,   261,   260,   255,   142,   251,   264,   704,   263,   202,
     263,   261,     1,   710,   261,   261,   713,   142,    33,   260,
     717,   159,   150,   264,    13,   263,   151,   152,    43,    84,
      19,    86,   202,   263,     1,   261,   174,     1,   263,   263,
     158,    95,   180,   181,   263,   260,   220,   263,   232,   264,
     263,   176,   115,    20,   172,   180,   263,     1,   263,   211,
     263,   179,  1226,  1227,  1228,   263,   263,   263,   261,   263,
     147,   263,   256,   263,   263,   263,   263,   261,   263,    46,
     143,   255,   263,   138,   263,    74,   263,   263,   263,    33,
     263,   263,   263,   250,   263,   233,   150,   160,   263,   263,
     263,   156,   263,   118,   256,   257,    70,   130,   263,   261,
     263,   261,     1,    80,    78,     4,    80,   255,     7,     8,
     263,   263,   263,   261,   263,    14,   263,   263,    72,   118,
     255,     1,    21,    22,    23,    24,   261,    81,    27,    28,
     263,   263,   263,    13,   199,   200,    35,    36,   263,   263,
      20,   118,    41,   263,   263,    44,    45,   263,   263,   263,
      49,   263,   106,   263,   263,   263,   110,    56,    57,   263,
      59,    60,    61,    62,   118,   142,    46,     5,   122,   123,
      69,   263,   146,   263,   263,   263,    75,    76,   263,   263,
     263,   263,   159,   182,   183,   263,    85,    25,   130,    88,
     255,   263,   263,   263,   259,   263,    34,   174,    97,   147,
      80,   263,   263,   180,   181,   263,   105,   263,   107,   263,
     109,   263,   111,   263,   113,   114,   263,    55,   263,   161,
     162,   163,   164,   165,   166,   167,   125,   263,   263,   128,
     147,   263,   263,   263,   263,   134,   135,   136,   137,   263,
     139,   140,   141,   263,   263,   144,    84,   263,    86,     1,
     260,     3,   263,   260,     6,   263,   233,   211,   232,   130,
     130,    13,   142,   243,   130,   130,   130,   130,    20,   130,
     243,   151,   152,   243,   173,   243,   260,   115,   255,   260,
     263,   263,   260,   243,    15,   184,   185,   186,   187,   188,
     189,   190,   191,   260,    46,   147,   176,   263,   263,   263,
     180,   263,   256,   257,  1392,   263,    86,   263,   263,    40,
     263,   263,   263,   263,   263,   153,    47,   155,    70,   263,
     219,    73,   263,   222,   263,   263,   263,    58,    80,   935,
     936,   937,   938,   939,   940,   941,     1,   263,   263,    91,
     178,   263,   263,   263,   263,   244,   245,   246,   263,   248,
     249,   263,   263,     0,     1,   254,    87,   263,     5,   258,
     263,   263,   200,   201,    29,    30,   118,   205,   263,    16,
     263,   209,    37,    20,   212,   255,   156,   215,    25,   263,
     218,   263,   263,    92,   263,    32,   224,   260,   119,   120,
     121,   263,    39,   243,   146,   263,   147,   235,   129,   147,
     238,    48,   240,   241,   147,   130,    53,    54,   243,   243,
     243,   147,    77,   193,   252,   130,   168,    82,    83,   243,
     200,   259,   243,   243,    89,    90,   157,     1,   180,   209,
     243,   130,    79,    98,    99,   100,   130,    84,   130,   243,
     243,   243,    86,    17,    18,   147,   177,    94,   130,   130,
     130,   130,    26,   130,   130,   235,   243,   237,   238,   243,
     243,   126,   127,   263,   263,    92,   263,   243,   243,   116,
     117,   243,   252,   147,   243,   243,   243,    51,    52,   259,
     232,   243,   243,   148,   147,   194,   147,   196,   130,   243,
     199,   138,   263,   243,   203,   260,   243,   260,   147,   263,
     260,   147,   147,   212,   256,   263,    80,   263,   217,   156,
     263,   242,   156,   147,   263,   260,   147,   263,   227,   263,
     229,   263,   263,   170,   171,   234,   263,   101,   102,   103,
     104,   263,   147,   263,   108,   263,   263,   260,   112,   263,
     260,   263,   263,   243,   118,   192,   263,   263,   130,   193,
     197,   263,   263,   263,   260,     1,   200,   131,   132,   263,
     263,   130,   263,   210,   260,   209,   263,   194,   263,   196,
     243,   145,   199,   243,   221,   243,   203,   243,   225,   243,
     147,   243,   147,   147,   231,   212,   130,   147,   147,   260,
     217,   235,    38,   237,   238,   169,   263,   147,   130,   130,
     227,   175,   229,   260,    50,   263,   243,   234,   252,   263,
     263,   263,   260,   263,   130,   259,   195,    63,    64,   198,
      66,    67,    68,   262,   260,   204,   130,   206,   260,   130,
     209,   260,   260,   263,   213,   214,   215,   195,   263,   263,
     198,   263,   216,   263,   223,   263,   204,    93,   206,   228,
     229,   209,   260,   260,   260,   213,   214,   215,   195,   260,
     239,   198,   260,   260,   260,   223,   260,   204,   260,   206,
     228,   229,   209,   260,   260,   260,   213,   214,   215,   260,
     260,   239,   260,   260,   260,   130,   223,   130,   263,   130,
     147,   228,   229,   130,   130,   130,   147,   260,   147,   147,
     243,   263,   239,   147,   130,   147,   260,   147,   147,   147,
     263,   260,   260,   147,   147,   147,   147,   147,   147,   147,
     147,   260,   147,   147,   260,   260,   260,   260,   147,   147,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   147,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   130,   260,   260,   147,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   243,   147,   147,   147,   260,   147,   147,   260,   147,
     147,   130,   263,   147,   260,   260,   260,   260,   147,   147,
     260,   147,   147,   147,   147,   147,   263,   147,   636,   147,
     243,   147,   243,   147,   147,   147,   243,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   673,  1416,   302,   438,
     130,   263,   147,   263,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,    83,   260,   260,
     260,   260,   260,   260,   260,   260,   260,  1256,   260,   260,
     263,   260,  1183,   263,   260,   262,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   154,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   154,   154,  1506,   260,   569,
     147,   260,   154,   154,   260,   260,   154,   260,   260,   260,
     260,   154,   154,   260,   154,   147,   147,  1456,  1454,   260,
     585,  1449,  1425,   260,   319,   260,  1441,   554,   528,  1305,
    1439,   410,   661,   602,   265,  1465,  1458,   645,  1430,   125,
     543,   260,   260,   260,   265,   265,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,  1269,   260,   260,   260,
     264,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   192,   449,
     260,   263,   263,   260,   260,   260,   260,   260,   260,   260,
    1267,  1262,   103,    -1,    -1,   265,   265,   265,   265,   265,
     265,   263,   263,   260,   260,    -1,    -1,   260,   263,   263,
     260,   260,    -1,    -1,   260,   260,   260,   280,    -1,   260,
      -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   430
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   267,     0,     1,     5,    16,    20,    25,    32,    39,
      48,    53,    54,    79,    84,    94,   116,   117,   138,   156,
     170,   171,   192,   197,   210,   221,   225,   231,   268,   273,
     281,   287,   303,   317,   323,   329,   338,   352,   376,   402,
     417,   434,   441,   445,   455,   464,   486,   492,   498,   502,
     508,   582,   599,   260,   261,   262,   262,   377,   465,   493,
     330,   262,   503,   262,   418,   487,   403,   262,   324,   353,
     435,   262,   262,   274,   456,   262,   262,   446,   288,     1,
      33,    43,   118,   318,   319,   320,   321,   322,     1,    29,
      30,    37,    77,    82,    83,    89,    90,    98,    99,   100,
     126,   127,   148,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   262,
     262,   262,   262,     1,    78,   499,   500,   501,   262,     1,
       4,     7,     8,    14,    21,    22,    23,    24,    27,    28,
      35,    36,    41,    44,    45,    49,    56,    57,    59,    60,
      61,    62,    69,    75,    76,    85,    88,    97,   105,   107,
     109,   111,   113,   114,   125,   128,   134,   135,   136,   137,
     139,   140,   141,   144,   173,   184,   185,   186,   187,   188,
     189,   190,   191,   219,   222,   244,   245,   246,   248,   249,
     254,   258,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   564,   565,   566,   569,
     573,   577,   578,   579,   580,   581,   262,   262,   262,     1,
     115,   143,   160,   282,   283,   284,   285,   286,   262,   262,
     262,     1,    38,    50,    63,    64,    66,    67,    68,    93,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       1,    33,    72,    81,   106,   110,   118,   122,   123,   211,
     256,   257,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   262,   262,     1,   253,   339,
     340,   341,   342,   343,     1,   118,   442,   443,   444,   262,
     262,   260,   263,   263,   263,   261,   319,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   261,   584,     1,    17,    18,    26,    51,    52,    80,
     101,   102,   103,   104,   108,   112,   118,   131,   132,   145,
     169,   175,   216,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     1,     3,     6,    13,    20,    46,
      70,    73,    80,    91,   118,   146,   168,   180,   232,   256,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   482,   483,   484,   485,     1,    78,   150,
     494,   495,   496,   497,     1,    96,   118,   150,   331,   332,
     333,   334,   335,   263,   261,   500,     1,   118,   150,   504,
     505,   506,   507,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   574,
     263,   570,   563,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   261,   510,     1,    13,    20,
      46,    80,   142,   151,   152,   176,   180,   255,   419,   420,
     421,   422,   423,   424,   425,   429,   430,   431,   432,   433,
       1,   150,   255,   488,   489,   490,   491,     1,    70,    78,
      80,   146,   232,   404,   408,   409,   410,   414,   415,   416,
     260,   263,   263,   263,   261,   283,     1,    95,   202,   325,
     326,   327,   328,     1,    20,    46,    80,   118,   142,   159,
     174,   180,   181,   233,   255,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   368,   372,     1,    48,
      95,   150,   436,   437,   438,   439,   440,   263,   263,   263,
     263,   263,   263,   263,   263,   261,   601,   260,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   261,
     305,     1,   118,   133,   220,   255,   275,   276,   277,   278,
     279,   280,     1,   118,   251,   457,   458,   459,   460,   260,
     263,   261,   340,   202,   263,   261,   443,     1,   118,   251,
     255,   447,   448,   449,   450,   451,     1,    13,    19,    74,
     118,   182,   183,   289,   290,   291,   292,   293,   294,   295,
     296,   147,   147,   147,   260,   130,   130,   243,   130,   270,
     130,   270,   270,   270,   130,   130,   130,   243,   243,   243,
     260,   260,   263,   263,   263,   263,   263,   399,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   261,   379,   260,   263,   263,   263,   263,   263,   263,
     263,   479,   263,   263,   263,   263,   263,   263,   263,   261,
     467,   263,   263,   261,   495,   260,   263,   263,   263,   261,
     332,   147,   260,   263,   263,   261,   505,   243,   243,   270,
     270,   147,   147,   147,   243,   243,   130,   243,   147,   130,
     243,   243,   243,   270,   243,   130,   130,   270,   130,   243,
     243,   243,   270,   147,   130,   130,   270,   130,   130,   130,
     130,   243,   243,   263,   243,   263,   263,   243,   270,   270,
     243,   243,   147,   243,   243,   247,   243,   247,   243,   243,
     243,   243,   147,   147,   130,   270,   243,   270,   270,   243,
     243,   260,   260,   263,   263,   263,   426,   263,   263,   263,
     263,   263,   263,   261,   420,   263,   263,   261,   489,   260,
     263,   263,   405,   263,   263,   261,   409,   147,   147,   147,
     260,   260,   263,   263,   261,   326,   260,   263,   263,   373,
     263,   263,   263,   369,   263,   263,   365,   263,   261,   355,
     260,   263,   263,   263,   261,   437,   243,   243,   243,   147,
     243,   243,   243,   270,   260,   147,   243,   147,   130,   130,
     147,   147,   147,   130,   147,   147,   260,   260,   263,   263,
     263,   263,   261,   276,   260,   263,   461,   261,   458,   243,
     260,   262,   147,   260,   260,   263,   452,   263,   261,   448,
     260,   263,   263,   297,   263,   263,   263,   261,   290,   260,
     260,   260,   260,   260,   260,   161,   162,   163,   164,   165,
     166,   167,   269,   270,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   130,   130,   270,   130,   130,
     263,   130,   130,   270,   130,   130,   270,   147,   130,   130,
     270,   130,   272,   272,   272,   260,   147,   207,   208,   147,
     147,   243,   147,   147,   263,   147,   147,   130,   147,   147,
     147,   147,   260,   147,   147,   260,   147,   336,   337,   147,
     147,   260,   260,   147,   147,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   195,   198,   204,   206,   209,   213,   214,   215,
     223,   228,   229,   239,   575,   576,   260,    92,   194,   196,
     199,   203,   212,   217,   227,   229,   234,   571,   572,   195,
     198,   204,   206,   209,   213,   214,   215,   223,   228,   229,
     239,   567,   568,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   147,   147,   243,
     263,   147,   130,   147,   147,   147,   147,   260,   147,   147,
     260,   147,   147,   263,   130,   412,   413,   147,   260,   260,
     260,   260,   147,   147,   260,   147,   243,   263,   147,   147,
     147,   263,   147,   243,   263,   147,   260,   147,   147,   147,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     147,   243,   147,   147,   260,   147,   263,   260,   260,     1,
     118,   226,   251,   344,   345,   346,   347,   348,   260,   147,
     263,   147,   260,   147,   147,   262,   147,   147,   147,   260,
     269,   269,   269,   269,   269,   269,   269,   260,   260,   260,
     260,   260,    65,   149,   400,   401,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,    10,    11,    12,   271,
     272,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,     9,   230,   480,   481,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   264,   260,   260,   260,
     260,   260,   264,   265,   265,   265,   260,   264,   260,   264,
     260,   260,   260,    15,    40,    47,    58,    87,   119,   120,
     121,   129,   157,   177,   242,   427,   428,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,    31,    63,    71,
     220,   230,   406,   407,   250,   264,   411,   260,   260,   260,
     260,   260,     5,    25,    34,    55,    84,    86,   115,   153,
     155,   178,   200,   201,   205,   209,   212,   215,   218,   224,
     235,   238,   240,   241,   252,   259,   374,   375,   260,   260,
     260,    92,   194,   196,   199,   203,   212,   217,   227,   229,
     234,   370,   371,   260,   260,   195,   198,   204,   206,   209,
     213,   214,   215,   223,   228,   229,   239,   366,   367,   260,
     260,   260,   260,   260,   260,   260,   260,   260,    86,   156,
     193,   200,   209,   235,   237,   238,   252,   259,   462,   463,
     260,   263,   263,   349,   261,   345,   260,    86,   156,   193,
     200,   209,   235,   237,   238,   252,   259,   453,   454,   260,
     260,   260,     1,   158,   172,   179,   298,   299,   300,   301,
     302,   260,   260,   260,   260,   264,   271,   271,   271,   260,
     264,   337,   576,   154,   154,   154,   572,   568,   260,   264,
     260,   264,   130,   413,   260,   265,   265,   265,   260,   264,
     265,   265,   265,   260,   264,   260,   264,   260,   264,   147,
     236,   272,   263,   260,   260,   264,   260,   263,   263,   263,
     261,   299,   401,   481,   428,   407,   154,   154,   154,   375,
     154,   154,   154,   371,   367,   463,   260,   260,   260,    55,
      84,    86,   138,   156,   199,   200,   255,   259,   350,   351,
     454,   147,   147,   147,   260,   260,   264,   260,   260,   260,
     351
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   266,   267,   267,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     269,   269,   270,   270,   270,   270,   270,   270,   270,   270,
     271,   271,   272,   272,   272,   272,   274,   273,   275,   275,
     276,   276,   276,   276,   276,   277,   278,   279,   280,   281,
     282,   282,   283,   283,   283,   283,   284,   285,   286,   288,
     287,   289,   289,   290,   290,   290,   290,   290,   290,   290,
     291,   292,   293,   294,   295,   297,   296,   298,   298,   299,
     299,   299,   299,   300,   301,   302,   303,   304,   304,   305,
     305,   305,   305,   305,   305,   305,   305,   305,   305,   305,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   318,   319,   319,   319,   319,   320,
     321,   322,   324,   323,   325,   325,   326,   326,   326,   327,
     328,   330,   329,   331,   331,   332,   332,   332,   332,   333,
     334,   335,   336,   336,   337,   338,   339,   339,   340,   340,
     340,   341,   343,   342,   344,   344,   345,   345,   345,   345,
     346,   347,   347,   349,   348,   350,   350,   351,   351,   351,
     351,   351,   351,   351,   351,   351,   353,   352,   354,   354,
     355,   355,   355,   355,   355,   355,   355,   355,   355,   355,
     355,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     365,   364,   366,   366,   367,   367,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   369,   368,   370,
     370,   371,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   371,   373,   372,   374,   374,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   375,
     375,   375,   375,   375,   375,   377,   376,   378,   378,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   399,   398,   400,
     400,   401,   401,   403,   402,   405,   404,   406,   406,   407,
     407,   407,   407,   407,   408,   408,   409,   409,   409,   409,
     409,   409,   411,   410,   412,   412,   413,   413,   414,   415,
     416,   418,   417,   419,   419,   420,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   421,   422,   423,   424,
     426,   425,   427,   427,   428,   428,   428,   428,   428,   428,
     428,   428,   428,   428,   428,   428,   429,   430,   431,   432,
     433,   435,   434,   436,   436,   437,   437,   437,   437,   438,
     439,   440,   441,   442,   442,   443,   443,   444,   446,   445,
     447,   447,   448,   448,   448,   448,   449,   450,   452,   451,
     453,   453,   454,   454,   454,   454,   454,   454,   454,   454,
     454,   454,   456,   455,   457,   457,   458,   458,   458,   459,
     461,   460,   462,   462,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   465,   464,   466,   466,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   477,   479,   478,   480,   480,   481,
     481,   482,   483,   484,   485,   487,   486,   488,   488,   489,
     489,   489,   490,   491,   493,   492,   494,   494,   495,   495,
     495,   496,   497,   498,   499,   499,   500,   500,   501,   503,
     502,   504,   504,   505,   505,   505,   506,   507,   508,   509,
     509,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   543,   544,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   563,   562,   564,
     565,   566,   567,   567,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   570,   569,   571,   571,
     572,   572,   572,   572,   572,   572,   572,   572,   572,   572,
     572,   572,   572,   574,   573,   575,   575,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   577,
     578,   579,   580,   581,   582,   583,   583,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   600,   601,
     601,   601,   601,   601,   601,   601,   601,   601,   602,   603,
     604,   605,   606,   607,   608,   609
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       0,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     2,     3,     3,     3,     0,     6,     2,     1,
       1,     1,     1,     1,     2,     4,     4,     4,     4,     5,
       2,     1,     1,     1,     1,     2,     4,     4,     4,     0,
       6,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     0,     6,     2,     1,     1,
       1,     1,     2,     4,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     5,     2,     1,     1,     1,     1,     2,     4,
       4,     4,     0,     6,     2,     1,     1,     1,     2,     4,
       4,     0,     6,     2,     1,     1,     1,     1,     2,     4,
       4,     4,     3,     1,     1,     5,     2,     1,     1,     1,
       2,     4,     0,     6,     2,     1,     1,     1,     1,     2,
       4,     4,     4,     0,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     6,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       0,     5,     3,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     3,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     0,     5,     3,     1,     3,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     6,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     0,     5,     3,
       1,     1,     1,     0,     6,     0,     5,     3,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     0,     5,     3,     1,     1,     3,     4,     4,
       4,     0,     6,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     4,     4,     4,     4,
       0,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     4,     4,     4,
       4,     0,     6,     2,     1,     1,     1,     1,     2,     4,
       4,     4,     5,     2,     1,     1,     1,     4,     0,     6,
       2,     1,     1,     1,     1,     2,     4,     4,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     2,     4,
       0,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     0,     5,     3,     1,     1,
       1,     4,     4,     4,     4,     0,     6,     2,     1,     1,
       1,     1,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     4,     4,     5,     2,     1,     1,     1,     4,     0,
       6,     2,     1,     1,     1,     1,     4,     4,     5,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     0,     5,     4,
       4,     4,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     3,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     0,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     5,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       4,     4,     4,     4,     4,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 30:
#line 454 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3112 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 456 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number);
		}
#line 3120 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 460 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number);
		}
#line 3128 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 464 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 + (yyvsp[0].number);
		}
#line 3136 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 468 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 + (yyvsp[0].number);
		}
#line 3144 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 472 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 + (yyvsp[0].number);
		}
#line 3152 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 476 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 + (yyvsp[0].number);
		}
#line 3160 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 480 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 * 4 + (yyvsp[0].number);
                }
#line 3168 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 484 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 365 + (yyvsp[0].number);
                }
#line 3176 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 489 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3182 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 490 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number); }
#line 3188 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 491 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 3194 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 492 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 + (yyvsp[0].number); }
#line 3200 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 493 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 * 1024 + (yyvsp[0].number); }
#line 3206 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 500 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.ptr.alias = MyMalloc(sizeof(struct alias_entry));
}
#line 3217 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 506 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  dlinkAdd(block_state.ptr.alias, &block_state.ptr.alias->node, &alias_items);
  alias_add(block_state.ptr.alias);
}
#line 3229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 518 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  struct alias_name *nm = MyMalloc(sizeof(struct alias_name));

  strlcpy(nm->name, yylval.string, sizeof(nm->name));
  nm->parent = block_state.ptr.alias;

  dlinkAdd(nm, &nm->node, &block_state.ptr.alias->names);
}
#line 3245 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 531 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->user, yylval.string, sizeof(block_state.ptr.alias->user));
}
#line 3254 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 537 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->server, yylval.string, sizeof(block_state.ptr.alias->server));
}
#line 3263 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 543 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.ptr.alias->flags |= CONF_FLAGS_OPER_ONLY;
  }
}
#line 3275 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 561 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_module(libio_basename(yylval.string));
}
#line 3284 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 567 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_script(yylval.string);
}
#line 3293 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 573 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    mod_add_path(yylval.string);
}
#line 3302 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 580 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.ssl = sslprofile_create();
}
#line 3313 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 587 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  dlink_node *ptr;

  if (conf_parser_ctx.pass != 1)
    break;

  DLINK_FOREACH(ptr, profile->identities.head)
  {
    struct sslprofile_identity *id = ptr->data;

    if (profile->dh)
      SSL_CTX_set_tmp_dh(id->server_ctx, profile->dh);

#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
    if (profile->curve)
      SSL_CTX_set_tmp_ecdh(id->server_ctx, profile->curve);
#endif

    if (!EmptyString(profile->cipher_list))
    {
      SSL_CTX_set_cipher_list(id->server_ctx, profile->cipher_list);

      SSL_CTX_set_cipher_list(id->client_ctx, profile->cipher_list);
    }

    if (!EmptyString(profile->ca_file))
    {
      if (!SSL_CTX_load_verify_locations(id->server_ctx, profile->ca_file, NULL))
      {
        const char *s = ERR_lib_error_string(ERR_get_error());

        ilog(LOG_TYPE_IRCD, "Could not load verify location %s -- %s", profile->ca_file, s);
      }
    }
  }

  dlinkAddTail(block_state.ptr.ssl, &block_state.ptr.ssl->node, &sslprofile_items);
  block_state.ptr.ssl = NULL;
}
#line 3358 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 635 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->name, yylval.string, sizeof(entry->name));
}
#line 3369 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 643 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
  {
    BIO *file = BIO_new_file(yylval.string, "r");

    if (file)
    {
      DH *dh = PEM_read_bio_DHparams(file, NULL, NULL, NULL);

      BIO_free(file);

      if (dh)
      {
        if (DH_size(dh) < 256)
        {
          conf_error_report("Ignoring sslprofile::dh_param_file -- need at least a 2048 bit DH prime size");
          DH_free(dh);
        }
        else
        {
          entry->dh = dh;
        }
      }
    }
    else
      conf_error_report("Ignoring sslprofile::dh_param_file -- could not open/read Diffie-Hellman parameter file");
  }
}
#line 3404 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 675 "conf_parser.y" /* yacc.c:1646  */
    {
#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
  struct sslprofile *entry = block_state.ptr.ssl;
  int nid = 0;
  EC_KEY *key = NULL;

  if (conf_parser_ctx.pass == 1)
  {
    if ((nid = OBJ_sn2nid(yylval.string)) == 0)
    {
        conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- unknown curve name");
        break;
    }

    if ((key = EC_KEY_new_by_curve_name(nid)) == NULL)
    {
      conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- could not create curve");
      break;
    }

    entry->curve = key;
  }
#endif
}
#line 3433 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 701 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->cipher_list, yylval.string, sizeof(entry->cipher_list));
}
#line 3444 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 709 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->ca_file, yylval.string, sizeof(entry->ca_file));
}
#line 3455 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 717 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.identity = sslprofile_identity_create(block_state.ptr.ssl);
}
#line 3466 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 724 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  struct sslprofile_identity *id = block_state.ptr.identity;

  if (conf_parser_ctx.pass != 1)
    break;

  if (id == NULL)
    break;

  dlinkAddTail(id, &id->node, &profile->identities);
  block_state.ptr.identity = NULL;
}
#line 3484 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 744 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  char *str;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  str = xstrdup(yylval.string);
  dlinkAdd(str, make_dlink_node(), &entry->server_names);
}
#line 3502 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 759 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  BIO *file = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  if (entry->rsa_private_key)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;
  }

  if (entry->rsa_private_key_file)
  {
    MyFree(entry->rsa_private_key_file);
    entry->rsa_private_key_file = NULL;
  }

  entry->rsa_private_key_file = xstrdup(yylval.string);

  if ((file = BIO_new_file(yylval.string, "r")) == NULL)
  {
    conf_error_report("File open failed, ignoring");
    break;
  }

  entry->rsa_private_key = PEM_read_bio_RSAPrivateKey(file, NULL, 0, NULL);

  BIO_set_close(file, BIO_CLOSE);
  BIO_free(file);

  if (entry->rsa_private_key == NULL)
  {
    conf_error_report("Couldn't extract key, ignoring");
    break;
  }

  if (!RSA_check_key(entry->rsa_private_key))
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Invalid key, ignoring");
    break;
  }

  if (RSA_size(entry->rsa_private_key) < 256)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Ignoring sslprofile::identity::rsa_private_key_file -- need at least a 2048 bit key size");
  }
}
#line 3565 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 819 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;

  if (conf_parser_ctx.pass == 1 && entry)
  {
    if (!entry->rsa_private_key_file)
    {
      conf_error_report("No rsa_private_key_file specified, SSL disabled");
      break;
    }

    if (SSL_CTX_use_certificate_chain_file(entry->server_ctx, yylval.string) <= 0 ||
        SSL_CTX_use_certificate_chain_file(entry->client_ctx, yylval.string) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not open/read certificate file");
      break;
    }

    if (SSL_CTX_use_PrivateKey_file(entry->server_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0 ||
        SSL_CTX_use_PrivateKey_file(entry->client_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }

    if (!SSL_CTX_check_private_key(entry->server_ctx) ||
        !SSL_CTX_check_private_key(entry->client_ctx))
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }
  }
}
#line 3608 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 873 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.name)
  {
    if (valid_servname(yylval.string))
      ServerInfo.name = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::name -- invalid name. Aborting.");
      exit(0);
    }
  }
}
#line 3626 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 888 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.sid)
  {
    if (valid_sid(yylval.string))
      ServerInfo.sid = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::sid -- invalid SID. Aborting.");
      exit(0);
    }
  }
}
#line 3644 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 903 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ServerInfo.description);
    ServerInfo.description = xstrdup(yylval.string);
  }
}
#line 3656 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 912 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    char *p;

    if ((p = strchr(yylval.string, ' ')) != NULL)
      *p = '\0';

    MyFree(ServerInfo.network_name);
    ServerInfo.network_name = xstrdup(yylval.string);
  }
}
#line 3673 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 926 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(ServerInfo.network_desc);
  ServerInfo.network_desc = xstrdup(yylval.string);
}
#line 3685 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 935 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip.ss.ss_family = res->ai_family;
      ServerInfo.ip.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv4_vhost = 1;
    }
  }
}
#line 3716 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 963 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost6(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip6, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip6.ss.ss_family = res->ai_family;
      ServerInfo.ip6.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv6_vhost = 1;
    }
  }
#endif
}
#line 3749 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 993 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < MAXCLIENTS_MIN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too low, setting to %d", MAXCLIENTS_MIN);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MIN;
  }
  else if ((yyvsp[-1].number) > MAXCLIENTS_MAX)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too high, setting to %d", MAXCLIENTS_MAX);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MAX;
  }
  else
    ServerInfo.max_clients = (yyvsp[-1].number);
}
#line 3777 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1018 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 9)
  {
    conf_error_report("max_nick_length too low, setting to 9");
    ServerInfo.max_nick_length = 9;
  }
  else if ((yyvsp[-1].number) > NICKLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_nick_length too high, setting to %d", NICKLEN);
    conf_error_report(buf);
    ServerInfo.max_nick_length = NICKLEN;
  }
  else
    ServerInfo.max_nick_length = (yyvsp[-1].number);
}
#line 3802 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1040 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 80)
  {
    conf_error_report("max_topic_length too low, setting to 80");
    ServerInfo.max_topic_length = 80;
  }
  else if ((yyvsp[-1].number) > TOPICLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_topic_length too high, setting to %d", TOPICLEN);
    conf_error_report(buf);
    ServerInfo.max_topic_length = TOPICLEN;
  }
  else
    ServerInfo.max_topic_length = (yyvsp[-1].number);
}
#line 3827 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1062 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ServerInfo.hub = yylval.number;
}
#line 3836 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1077 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.name);
  AdminInfo.name = xstrdup(yylval.string);
}
#line 3848 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1086 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.email);
  AdminInfo.email = xstrdup(yylval.string);
}
#line 3860 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1095 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.description);
  AdminInfo.description = xstrdup(yylval.string);
}
#line 3872 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1107 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 3881 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1111 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.file.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
    motd_add(ptr->data, block_state.file.buf);
}
#line 3898 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1128 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 3907 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1134 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 3916 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1144 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    reset_block_state();
    block_state.ptr.dnsbl = MyMalloc(sizeof(struct dnsbl_entry));
  }
}
#line 3928 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1152 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_entry *dnsbl = block_state.ptr.dnsbl;
    dlinkAdd(dnsbl, &dnsbl->node, &dnsbl_items);
  }
}
#line 3940 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1165 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->name, yylval.string, sizeof(block_state.ptr.dnsbl->name));
}
#line 3949 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1171 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->reason, yylval.string, sizeof(block_state.ptr.dnsbl->reason));
}
#line 3958 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1179 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));

    if (parse_netmask((yyvsp[0].string), &match->ip, &match->bits) == HM_IPV4)
    {
      dlinkAdd(match, &match->node, &block_state.ptr.dnsbl->matches);
    }
    else
    {
      char buf[IRCD_BUFSIZE];

      snprintf(buf, sizeof(buf), "dnsbl match %s not an IPv4 mask, ignored", (yyvsp[0].string));
      conf_error_report(buf);

      MyFree(match);
    }
  }
}
#line 3983 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1210 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigLoggingEntry.use_logging = yylval.number;
}
#line 3992 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1216 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 4001 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1220 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (block_state.type.value && block_state.file.buf[0])
    log_set_file(block_state.type.value, block_state.size.value,
                 block_state.file.buf);
}
#line 4014 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1236 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4025 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1244 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = (yyvsp[-1].number);
}
#line 4033 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1247 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = 0;
}
#line 4041 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1252 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = 0;
}
#line 4050 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1259 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_USER;
}
#line 4059 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1263 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_OPER;
}
#line 4068 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1267 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_GLINE;
}
#line 4077 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1271 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_XLINE;
}
#line 4086 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1275 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_RESV;
}
#line 4095 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1279 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DLINE;
}
#line 4104 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1283 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KLINE;
}
#line 4113 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1287 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KILL;
}
#line 4122 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1291 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DEBUG;
}
#line 4131 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1301 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
}
#line 4143 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1308 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;
  if (!block_state.file.buf[0] &&
      !block_state.rpass.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    conf         = conf_make(CONF_OPER);
    conf->name   = xstrdup(block_state.name.buf);
    conf->user   = xstrdup(block_state.user.buf);
    conf->host   = xstrdup(block_state.host.buf);

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);

    conf->flags = block_state.flags.value;
    conf->modes = block_state.modes.value;
    conf->snomask.local = block_state.snomask_local.value;
    conf->snomask.remote = block_state.snomask_remote.value;
    conf->port  = block_state.port.value;
    conf->htype = parse_netmask(conf->host, &conf->addr, &conf->bits);

    conf_add_class_to_conf(conf, block_state.class.buf);

    if (block_state.file.buf[0])
    {
      BIO *file = NULL;
      RSA *pkey = NULL;

      if ((file = BIO_new_file(block_state.file.buf, "r")) == NULL)
      {
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- file doesn't exist");
        break;
      }

      if ((pkey = PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL)) == NULL)
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- Key invalid; check key syntax");
      else
      {
        if (RSA_size(pkey) > 128)
          ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- key size must be 1024 or below");
        else
          conf->rsa_public_key = pkey;
      }

      BIO_set_close(file, BIO_CLOSE);
      BIO_free(file);
    }
  }
}
#line 4220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1389 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 4229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1395 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 4238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1401 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 4247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1407 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
  else
    block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
}
#line 4261 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1418 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4270 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1424 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 4279 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1430 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_SSL;
  else
    block_state.flags.value &= ~CONF_FLAGS_SSL;
}
#line 4293 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1441 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4302 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1447 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value = 0;
}
#line 4311 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1455 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_NOCTCP;
}
#line 4320 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1460 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_DEAF;
}
#line 4329 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1465 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_HIDECHANNELS;
}
#line 4338 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1470 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_OPERWALL;
}
#line 4347 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1475 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SERVNOTICE;
}
#line 4356 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1480 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_INVISIBLE;
}
#line 4365 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1485 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_WALLOP;
}
#line 4374 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1490 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SOFTCALLERID;
}
#line 4383 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1495 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_CALLERID;
}
#line 4392 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1500 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_LOCOPS;
}
#line 4401 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1505 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_REGONLY;
}
#line 4410 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1510 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SPY;
}
#line 4419 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1516 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value = block_state.snomask_remote.value = 0;
}
#line 4428 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1524 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_bots.flag;
}
#line 4437 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1529 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_bots.flag;
}
#line 4446 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1534 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_cconn.flag;
}
#line 4455 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1539 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_cconn.flag;
}
#line 4464 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1544 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_debug.flag;
}
#line 4473 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1549 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_full.flag;
}
#line 4482 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1554 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_skill.flag;
}
#line 4491 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1559 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_nchange.flag;
}
#line 4500 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1564 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_rej.flag;
}
#line 4509 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1569 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_unauth.flag;
}
#line 4518 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_spy.flag;
}
#line 4527 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1579 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_link.flag;
}
#line 4536 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1584 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
     block_state.snomask_local.value |= sno_link.flag;
}
#line 4545 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1590 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = 0;
}
#line 4554 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1597 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL_REMOTE;
}
#line 4563 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1601 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_FARCONNECT;
}
#line 4572 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1605 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_N;
}
#line 4581 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1609 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL;
}
#line 4590 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1613 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT_REMOTE;
}
#line 4599 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1617 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT;
}
#line 4608 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1621 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT_REMOTE;
}
#line 4617 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1625 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT;
}
#line 4626 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1629 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_K;
}
#line 4635 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1633 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNKLINE;
}
#line 4644 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1637 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DLINE;
}
#line 4653 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1641 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNDLINE;
}
#line 4662 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1645 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_XLINE;
}
#line 4671 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1649 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNXLINE;
}
#line 4680 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1653 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLINE;
}
#line 4689 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1657 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DIE;
}
#line 4698 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1661 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_RESTART;
}
#line 4707 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1665 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REHASH;
}
#line 4716 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1669 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_ADMIN;
}
#line 4725 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1673 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_OPERWALL;
}
#line 4734 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1677 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLOBOPS;
}
#line 4743 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1681 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLOPS;
}
#line 4752 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1685 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLUSERS;
}
#line 4761 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1689 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_LOCOPS;
}
#line 4770 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1693 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REMOTEBAN;
}
#line 4779 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1697 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SET;
}
#line 4788 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1701 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_MODULE;
}
#line 4797 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1711 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();

  block_state.ping_freq.value = DEFAULT_PINGFREQUENCY;
  block_state.con_freq.value  = DEFAULT_CONNECTFREQUENCY;
  block_state.max_total.value = MAXIMUM_LINKS_DEFAULT;
  block_state.max_sendq.value = DEFAULT_SENDQ;
  block_state.max_recvq.value = DEFAULT_RECVQ;
}
#line 4814 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1723 "conf_parser.y" /* yacc.c:1646  */
    {
  struct ClassItem *class = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (!block_state.class.buf[0])
    break;

  if (!(class = class_find(block_state.class.buf, 0)))
    class = class_make();

  class->active = 1;
  MyFree(class->name);
  class->name = xstrdup(block_state.class.buf);
  class->ping_freq = block_state.ping_freq.value;
  class->max_perip = block_state.max_perip.value;
  class->con_freq = block_state.con_freq.value;
  class->max_total = block_state.max_total.value;
  class->max_global = block_state.max_global.value;
  class->max_local = block_state.max_local.value;
  class->max_ident = block_state.max_ident.value;
  class->soft_sendq = block_state.soft_sendq.value;
  class->flood_burst = block_state.flood_burst.value;
  class->flood_limit = block_state.flood_limit.value;
  class->max_sendq = block_state.max_sendq.value;
  class->max_recvq = block_state.max_recvq.value;

  if (block_state.min_idle.value > block_state.max_idle.value)
  {
    block_state.min_idle.value = 0;
    block_state.max_idle.value = 0;
    block_state.flags.value &= ~CLASS_FLAGS_FAKE_IDLE;
  }

  class->flags = block_state.flags.value;
  class->min_idle = block_state.min_idle.value;
  class->max_idle = block_state.max_idle.value;

  rebuild_cidr_list(class);

  class->cidr_bitlen_ipv4 = block_state.cidr_bitlen_ipv4.value;
  class->cidr_bitlen_ipv6 = block_state.cidr_bitlen_ipv6.value;
  class->number_per_cidr = block_state.number_per_cidr.value;
}
#line 4864 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1787 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4873 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1793 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ping_freq.value = (yyvsp[-1].number);
}
#line 4882 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1799 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_perip.value = (yyvsp[-1].number);
}
#line 4891 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1805 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.con_freq.value = (yyvsp[-1].number);
}
#line 4900 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1811 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_total.value = (yyvsp[-1].number);
}
#line 4909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1817 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_global.value = (yyvsp[-1].number);
}
#line 4918 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1823 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_local.value = (yyvsp[-1].number);
}
#line 4927 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1829 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_ident.value = (yyvsp[-1].number);
}
#line 4936 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1835 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.soft_sendq.value = (yyvsp[-1].number);
}
#line 4945 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1841 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_burst.value = (yyvsp[-1].number);
}
#line 4954 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1847 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_limit.value = (yyvsp[-1].number);
}
#line 4963 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1853 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_sendq.value = (yyvsp[-1].number);
}
#line 4972 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1859 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    if ((yyvsp[-1].number) >= CLIENT_FLOOD_MIN && (yyvsp[-1].number) <= CLIENT_FLOOD_MAX)
      block_state.max_recvq.value = (yyvsp[-1].number);
}
#line 4982 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1866 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv4.value = (yyvsp[-1].number) > 32 ? 32 : (yyvsp[-1].number);
}
#line 4991 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1872 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv6.value = (yyvsp[-1].number) > 128 ? 128 : (yyvsp[-1].number);
}
#line 5000 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1878 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.number_per_cidr.value = (yyvsp[-1].number);
}
#line 5009 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1884 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.min_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5021 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1893 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.max_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5033 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1902 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value &= CLASS_FLAGS_FAKE_IDLE;
}
#line 5042 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1909 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_RANDOM_IDLE;
}
#line 5051 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1913 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_HIDE_IDLE_FROM_OPERS;
}
#line 5060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1923 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5069 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1929 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5078 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1936 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_SSL;
}
#line 5087 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1940 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HIDDEN;
}
#line 5096 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1944 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
   block_state.flags.value |= LISTENER_SERVER;
}
#line 5105 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1948 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HTTP;
}
#line 5114 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1952 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_DEFER;
}
#line 5123 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1961 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5132 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1969 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    add_listener((yyvsp[0].number), block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5156 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1988 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    int i;
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    for (i = (yyvsp[-2].number); i <= (yyvsp[0].number); ++i)
      add_listener(i, block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5182 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2011 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5191 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2017 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5200 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2023 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 5209 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2032 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5218 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2036 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    if (EmptyString(block_state.host.buf))
      continue;

    conf        = conf_make(CONF_CLIENT);
    conf->user  = xstrdup(block_state.user.buf);
    conf->host  = xstrdup(block_state.host.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);
    if (block_state.name.buf[0])
      conf->name = xstrdup(block_state.name.buf);

    conf->flags = block_state.flags.value;
    conf->port  = block_state.port.value;

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.ca.buf[0])
    {
      int ret;

      conf->x509_store = X509_STORE_new();
      ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
      if (ret != 1)
      {
        X509_STORE_free(conf->x509_store);
        conf->x509_store = NULL;

        ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring auth block", block_state.ca.buf);
        conf_free(conf);
        continue;
      }
    }

    conf_add_class_to_conf(conf, block_state.class.buf);
    add_conf_by_address(CONF_CLIENT, conf);
  }
}
#line 5282 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2103 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5291 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2109 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5300 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2115 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5309 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2121 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 5323 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2132 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value &= (CONF_FLAGS_ENCRYPTED | CONF_FLAGS_SPOOF_IP);
}
#line 5332 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2139 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SPOOF_NOTICE;
}
#line 5341 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2143 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NOLIMIT;
}
#line 5350 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2147 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTKLINE;
}
#line 5359 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2151 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTDNSBL;
}
#line 5368 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2155 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_IDENTD;
}
#line 5377 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2159 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_CAN_FLOOD;
}
#line 5386 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2163 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NO_TILDE;
}
#line 5395 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2167 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTGLINE;
}
#line 5404 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2171 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTRESV;
}
#line 5413 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2175 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_WEBIRC;
}
#line 5422 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2179 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_ACCOUNT;
}
#line 5431 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2183 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_PASSWORD;
}
#line 5440 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2189 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (strlen(yylval.string) <= HOSTLEN && valid_hostname(yylval.string))
  {
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
    block_state.flags.value |= CONF_FLAGS_SPOOF_IP;
  }
  else
    ilog(LOG_TYPE_IRCD, "Spoof either is too long or contains invalid characters. Ignoring it.");
}
#line 5457 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2203 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
  block_state.flags.value |= CONF_FLAGS_REDIR;
}
#line 5469 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2212 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.flags.value |= CONF_FLAGS_REDIR;
  block_state.port.value = (yyvsp[-1].number);
}
#line 5481 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2221 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 5492 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2229 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 5503 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2241 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  strlcpy(block_state.rpass.buf, CONF_NOREASON, sizeof(block_state.rpass.buf));
}
#line 5515 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2248 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  create_resv(block_state.name.buf, block_state.rpass.buf, &block_state.mask.list);
}
#line 5526 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2259 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5535 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2265 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5544 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2271 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5553 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2286 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (valid_servname(yylval.string))
  {
    struct MaskItem *conf = conf_make(CONF_SERVICE);
    conf->name = xstrdup(yylval.string);
  }
}
#line 5568 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2301 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  strlcpy(block_state.user.buf, "*", sizeof(block_state.user.buf));
  strlcpy(block_state.host.buf, "*", sizeof(block_state.host.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5584 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2312 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_ULINE);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);
}
#line 5601 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2329 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5610 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2335 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 5632 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2354 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5641 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2361 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5650 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2365 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5659 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2369 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5668 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2373 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5677 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2377 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5686 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2381 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5695 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2385 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5704 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2389 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5713 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2393 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5722 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2397 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5731 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2406 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5745 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2415 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_CLUSTER);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
}
#line 5760 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2430 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5769 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2436 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5778 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2443 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5787 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2447 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5796 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2451 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5805 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2455 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5814 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2459 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5823 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2463 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5832 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2467 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5841 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2471 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5850 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2475 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5859 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2479 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5868 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2488 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.aftype.value = AF_INET;
  block_state.port.value = PORTNUM;
}
#line 5882 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2497 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;
  struct addrinfo hints, *res;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0] ||
      !block_state.host.buf[0])
    break;

  if (!block_state.rpass.buf[0] ||
      !block_state.spass.buf[0])
    break;

  if (has_wildcards(block_state.name.buf))
    break;

  conf = conf_make(CONF_SERVER);
  conf->port = block_state.port.value;
  conf->flags = block_state.flags.value;
  conf->aftype = block_state.aftype.value;
  conf->host = xstrdup(block_state.host.buf);
  conf->name = xstrdup(block_state.name.buf);
  conf->passwd = xstrdup(block_state.rpass.buf);
  conf->spasswd = xstrdup(block_state.spass.buf);

  if (block_state.cert.buf[0])
    conf->certfp = xstrdup(block_state.cert.buf);

  dlinkMoveList(&block_state.leaf.list, &conf->leaf_list);
  dlinkMoveList(&block_state.hub.list, &conf->hub_list);

  if (block_state.bind.buf[0])
  {
    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(block_state.bind.buf, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", block_state.bind.buf);
    else
    {
      assert(res != NULL);

      memcpy(&conf->bind, res->ai_addr, res->ai_addrlen);
      conf->bind.ss.ss_family = res->ai_family;
      conf->bind.ss_len = res->ai_addrlen;
      freeaddrinfo(res);
    }
  }

  if (block_state.ca.buf[0])
  {
    int ret;

    conf->x509_store = X509_STORE_new();
    ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
    if (ret != 1)
    {
      X509_STORE_free(conf->x509_store);
      conf->x509_store = NULL;

      ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring connect block", block_state.ca.buf);
      conf_free(conf);
      break;
    }
  }

  conf->ssl_profile = xstrdup(block_state.profile.buf);

  conf_add_class_to_conf(conf, block_state.class.buf);
  lookup_confhost(conf);
}
#line 5963 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2584 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5972 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2590 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.host.buf, yylval.string, sizeof(block_state.host.buf));
}
#line 5981 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2596 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.bind.buf, yylval.string, sizeof(block_state.bind.buf));
}
#line 5990 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2602 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.spass.buf, yylval.string, sizeof(block_state.spass.buf));
}
#line 6006 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2615 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6022 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2628 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 6031 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2634 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 6040 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2640 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 6049 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2646 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = (yyvsp[-1].number);
}
#line 6058 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2652 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET;
}
#line 6067 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2656 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET6;
#endif
}
#line 6078 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2664 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value &= CONF_FLAGS_ENCRYPTED;
}
#line 6086 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2670 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_ALLOW_AUTO_CONN;
}
#line 6095 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2674 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SSL;
}
#line 6104 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2680 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 6118 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2691 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.hub.list);
}
#line 6127 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2697 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.leaf.list);
}
#line 6136 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2703 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 6145 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2713 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6154 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2717 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.user.buf[0] ||
      !block_state.host.buf[0])
    break;

  conf = conf_make(CONF_KLINE);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
  add_conf_by_address(CONF_KLINE, conf);
}
#line 6179 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2742 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 6202 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2762 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6211 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2771 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2775 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.addr.buf[0])
    break;

  if (parse_netmask(block_state.addr.buf, NULL, NULL) != HM_HOST)
  {
    conf = conf_make(CONF_DLINE);
    conf->host = xstrdup(block_state.addr.buf);

    if (block_state.rpass.buf[0])
      conf->reason = xstrdup(block_state.rpass.buf);
    else
      conf->reason = xstrdup(CONF_NOREASON);
    add_conf_by_address(CONF_DLINE, conf);
  }
}
#line 6246 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2801 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 6255 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2807 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6264 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2821 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.string[0] && parse_netmask(yylval.string, NULL, NULL) != HM_HOST)
    {
      struct MaskItem *conf = conf_make(CONF_EXEMPT);
      conf->host = xstrdup(yylval.string);

      add_conf_by_address(CONF_EXEMPT, conf);
    }
  }
}
#line 6281 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2838 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6290 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2842 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;

  conf = conf_make(CONF_XLINE);
  conf->name = xstrdup(block_state.name.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
}
#line 6312 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2864 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6321 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2870 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6330 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2918 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_watch = (yyvsp[-1].number);
}
#line 6338 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2923 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cycle_on_host_change = yylval.number;
}
#line 6347 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2929 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key1);
    ConfigFileEntry.cloak_key1 = xstrdup(yylval.string);
  }
}
#line 6359 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2938 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key2);
    ConfigFileEntry.cloak_key2 = xstrdup(yylval.string);
  }
}
#line 6371 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2947 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key3);
    ConfigFileEntry.cloak_key3 = xstrdup(yylval.string);
  }
}
#line 6383 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2956 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cloak_whois_actually = yylval.number;
}
#line 6392 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2962 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.account_whois = yylval.number;
}
#line 6401 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2968 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.glines = yylval.number;
}
#line 6410 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2974 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_time = (yyvsp[-1].number);
}
#line 6419 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2980 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_request_time = (yyvsp[-1].number);
}
#line 6428 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2986 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr = (yyvsp[-1].number);
}
#line 6436 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2991 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr6 = (yyvsp[-1].number);
}
#line 6444 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2996 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.kline_reason);
    ConfigFileEntry.kline_reason = xstrdup(yylval.string);
  }
}
#line 6456 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 607:
#line 3005 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.tkline_expire_notices = yylval.number;
}
#line 6464 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 608:
#line 3010 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.kill_chase_time_limit = (yyvsp[-1].number);
}
#line 6472 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 609:
#line 3015 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.hide_spoof_ips = yylval.number;
}
#line 6480 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 610:
#line 3020 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ignore_bogus_ts = yylval.number;
}
#line 6488 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 611:
#line 3025 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.failed_oper_notice = yylval.number;
}
#line 6496 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 612:
#line 3030 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_nick_flood = yylval.number;
}
#line 6504 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 613:
#line 3035 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_time = (yyvsp[-1].number);
}
#line 6512 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 614:
#line 3040 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_changes = (yyvsp[-1].number);
}
#line 6520 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 615:
#line 3045 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_accept = (yyvsp[-1].number);
}
#line 6528 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 616:
#line 3050 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_spam_exit_message_time = (yyvsp[-1].number);
}
#line 6536 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 617:
#line 3055 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ts_warn_delta = (yyvsp[-1].number);
}
#line 6544 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 618:
#line 3060 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.ts_max_delta = (yyvsp[-1].number);
}
#line 6553 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 619:
#line 3066 "conf_parser.y" /* yacc.c:1646  */
    {
  if (((yyvsp[-1].number) > 0) && conf_parser_ctx.pass == 1)
  {
    ilog(LOG_TYPE_IRCD, "You haven't read your config file properly.");
    ilog(LOG_TYPE_IRCD, "There is a line in the example conf that will kill your server if not removed.");
    ilog(LOG_TYPE_IRCD, "Consider actually reading/editing the conf file, and removing this line.");
    exit(0);
  }
}
#line 6567 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 620:
#line 3077 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.invisible_on_connect = yylval.number;
}
#line 6575 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 621:
#line 3082 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.warn_no_nline = yylval.number;
}
#line 6583 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 622:
#line 3087 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_e_disabled = yylval.number;
}
#line 6591 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 623:
#line 3092 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_o_oper_only = yylval.number;
}
#line 6599 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 624:
#line 3097 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_P_oper_only = yylval.number;
}
#line 6607 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 625:
#line 3102 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_u_oper_only = yylval.number;
}
#line 6615 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 626:
#line 3107 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 2 * yylval.number;
}
#line 6623 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 627:
#line 3110 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 1;
}
#line 6631 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 628:
#line 3115 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 2 * yylval.number;
}
#line 6639 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 629:
#line 3118 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 1;
}
#line 6647 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 630:
#line 3123 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_m_oper_only = yylval.number;
}
#line 6655 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 631:
#line 3128 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait = (yyvsp[-1].number);
}
#line 6663 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 632:
#line 3133 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.caller_id_wait = (yyvsp[-1].number);
}
#line 6671 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 633:
#line 3138 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.opers_bypass_callerid = yylval.number;
}
#line 6679 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 634:
#line 3143 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait_simple = (yyvsp[-1].number);
}
#line 6687 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 635:
#line 3148 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.short_motd = yylval.number;
}
#line 6695 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 636:
#line 3153 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.no_oper_flood = yylval.number;
}
#line 6703 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 637:
#line 3158 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_pass_resv = yylval.number;
}
#line 6711 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 638:
#line 3163 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.dots_in_ident = (yyvsp[-1].number);
}
#line 6719 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 639:
#line 3168 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_targets = (yyvsp[-1].number);
}
#line 6727 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 640:
#line 3173 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && valid_servname(yylval.string))
  {
    MyFree(ConfigFileEntry.service_name);
    ConfigFileEntry.service_name = xstrdup(yylval.string);
  }
}
#line 6739 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 641:
#line 3182 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.sasl_name);
    ConfigFileEntry.sasl_name = xstrdup(yylval.string);
  }
}
#line 6751 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 642:
#line 3191 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ping_cookie = yylval.number;
}
#line 6759 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 643:
#line 3196 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.nick_collide_realhost = yylval.number;
}
#line 6767 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 644:
#line 3201 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.disable_auth = yylval.number;
}
#line 6775 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 645:
#line 3206 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_num = yylval.number;
}
#line 6783 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 646:
#line 3211 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_time = (yyvsp[-1].number);
}
#line 6791 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 647:
#line 3216 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes = 0;
}
#line 6799 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 649:
#line 3221 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_extbans = yylval.number;
}
#line 6807 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3226 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_forwarding = yylval.number;
}
#line 6815 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3231 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if ((ConfigFileEntry.message_digest_algorithm = EVP_get_digestbyname(yylval.string)) == NULL)
    {
      ConfigFileEntry.message_digest_algorithm = EVP_sha1();
      conf_error_report("Ignoring general::ssl_message_digest_algorithm -- unknown message digest algorithm");
    }
  }
}
#line 6830 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 654:
#line 3244 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_NOCTCP;
}
#line 6838 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3248 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEAF;
}
#line 6846 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 656:
#line 3252 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_HIDECHANNELS;
}
#line 6854 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3256 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_OPERWALL;
}
#line 6862 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3260 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SERVNOTICE;
}
#line 6870 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3264 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_INVISIBLE;
}
#line 6878 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3268 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_WALLOP;
}
#line 6886 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 661:
#line 3272 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SOFTCALLERID;
}
#line 6894 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 662:
#line 3276 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_CALLERID;
}
#line 6902 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3280 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_LOCOPS;
}
#line 6910 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 664:
#line 3284 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_REGONLY;
}
#line 6918 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 665:
#line 3288 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SPY;
}
#line 6926 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3293 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local = ConfigFileEntry.oper_snomasks.remote = 0;
}
#line 6934 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 670:
#line 3300 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_bots.flag;
}
#line 6942 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3304 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_bots.flag;
}
#line 6950 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 672:
#line 3308 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_cconn.flag;
}
#line 6958 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 673:
#line 3312 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_cconn.flag;
}
#line 6966 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 674:
#line 3316 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_debug.flag;
}
#line 6974 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 675:
#line 3320 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_nchange.flag;
}
#line 6982 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3324 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_full.flag;
}
#line 6990 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 677:
#line 3328 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_skill.flag;
}
#line 6998 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3332 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_rej.flag;
}
#line 7006 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3336 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_unauth.flag;
}
#line 7014 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3340 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_spy.flag;
}
#line 7022 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3344 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_link.flag;
}
#line 7030 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 682:
#line 3348 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_link.flag;
}
#line 7038 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 683:
#line 3353 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes = 0;
}
#line 7046 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 687:
#line 3359 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_NOCTCP;
}
#line 7054 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 688:
#line 3363 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEAF;
}
#line 7062 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 689:
#line 3367 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_HIDECHANNELS;
}
#line 7070 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 690:
#line 3371 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_OPERWALL;
}
#line 7078 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3375 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SERVNOTICE;
}
#line 7086 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3379 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_INVISIBLE;
}
#line 7094 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3383 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_WALLOP;
}
#line 7102 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3387 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SOFTCALLERID;
}
#line 7110 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3391 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CALLERID;
}
#line 7118 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3395 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_LOCOPS;
}
#line 7126 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 697:
#line 3399 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_REGONLY;
}
#line 7134 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3403 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SPY;
}
#line 7142 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 699:
#line 3408 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.disable_chmodes);
    ConfigFileEntry.disable_chmodes = xstrdup(yylval.string);
  }
}
#line 7154 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 700:
#line 3417 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.use_target_change = yylval.number;
}
#line 7162 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 701:
#line 3422 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard = (yyvsp[-1].number);
}
#line 7170 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 702:
#line 3427 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard_simple = (yyvsp[-1].number);
}
#line 7178 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 703:
#line 3432 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodcount = (yyvsp[-1].number);
}
#line 7186 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 722:
#line 3456 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.disable_fake_channels = yylval.number;
}
#line 7194 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 723:
#line 3461 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay = (yyvsp[-1].number);
}
#line 7202 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 724:
#line 3466 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay_channel = (yyvsp[-1].number);
}
#line 7210 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 725:
#line 3471 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_user = (yyvsp[-1].number);
}
#line 7218 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 726:
#line 3476 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_oper = (yyvsp[-1].number);
}
#line 7226 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 727:
#line 3481 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_bans = (yyvsp[-1].number);
}
#line 7234 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 728:
#line 3486 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_user_count = (yyvsp[-1].number);
}
#line 7242 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 729:
#line 3491 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_server_count = (yyvsp[-1].number);
}
#line 7250 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 730:
#line 3496 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_create_on_split = yylval.number;
}
#line 7258 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 731:
#line 3501 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_join_on_split = yylval.number;
}
#line 7266 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 732:
#line 3506 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodcount = yylval.number;
}
#line 7274 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 733:
#line 3511 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodtime = (yyvsp[-1].number);
}
#line 7282 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 734:
#line 3516 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.quiet_on_ban = yylval.number;
}
#line 7290 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 735:
#line 3521 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.invite_throttle = (yyvsp[-1].number);
}
#line 7298 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3541 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.flatten_links = yylval.number;
}
#line 7307 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3547 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.disable_remote_commands = yylval.number;
}
#line 7316 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3553 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_servers = yylval.number;
}
#line 7325 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3559 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_services = yylval.number;
}
#line 7334 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3565 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigServerHide.hidden_name);
    ConfigServerHide.hidden_name = xstrdup(yylval.string);
  }
}
#line 7346 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (((yyvsp[-1].number) > 0) && ConfigServerHide.links_disabled == 1)
    {
      eventAddIsh("write_links_file", write_links_file, NULL, (yyvsp[-1].number));
      ConfigServerHide.links_disabled = 0;
    }

    ConfigServerHide.links_delay = (yyvsp[-1].number);
  }
}
#line 7363 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3588 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hidden = yylval.number;
}
#line 7372 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3594 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_server_ips = yylval.number;
}
#line 7381 "conf_parser.c" /* yacc.c:1646  */
    break;


#line 7385 "conf_parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
